// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

class CabIRInfo: public lv2c::ui::Lv2PluginInfo{
public:
    static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-cab-ir-ui";
    using super=lv2c::ui::Lv2PluginInfo;
    using ptr=std::shared_ptr<CabIRInfo>;
    static ptr Create() { return std::make_shared<CabIRInfo>(); }

    CabIRInfo() {
        using namespace lv2c::ui;

        uri("http://two-play.com/plugins/toob-cab-ir");
        name("TooB Cab IR");
        brand("TooB");
        label("Cab IR");
        plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
        supported_features({"http://lv2plug.in/ns/ext/state#:freePath","http://lv2plug.in/ns/lv2core#hardRTCapable","http://lv2plug.in/ns/ext/state#makePath","http://lv2plug.in/ns/ext/urid#map","http://lv2plug.in/ns/ext/state#mapPath","http://lv2plug.in/ns/ext/worker#schedule"});
        required_features({"http://lv2plug.in/ns/ext/urid#map"});
        optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable","http://lv2plug.in/ns/ext/state#:freePath","http://lv2plug.in/ns/ext/worker#schedule","http://lv2plug.in/ns/ext/state#makePath","http://lv2plug.in/ns/ext/state#mapPath"});
        author_name("Robin Davies");
        author_homepage("https://github.com/sponsors/rerdavies");
        comment("TooB Cab IR is a convolution-based guitar cabinet impulse response simulator.\n\nTooB Cab IR allows you to select and mix impulse responses for up to three microphone positions. Mixing is done before convolution FFTs are calculated,\nso there is no performance cost for using more than one impulse response file. \n\nCab IR files are usually short, but sometimes include room response impulse files, which can be quite long. The Max T control determines the maximum length\nto use for impulse response files. If the length of the impulse file is longer than the specified time, samples occurring after \nthe specified time are discarded, and the tail of the impulse convolution is fed back into the input of the convolution. This ensures a smooth reverb tail, \nand has little effect on the quality of the resulting reverb. If the impulse file is shorter than the specified time, then all samples in the impulse \nfile are used, and no feedback occurs.\n\nToob Convolution Reverb comes with a basic set of cabinet impulse files to get you started. There are, however, a rich variety of both free and commercial\ncabinet impulse response files available on the internet. You are strongly encouraged to explore alternate sources of cab IR files.\n\nSpecial thanks are extended to Kristoffer Ekstrand of Adventure Kid Research &amp; Technology, who \ngenerously provided the base set of impulse files distributed with TooB Cab IR under a CC-BY-4.0 license.\n\n---\n\nThe following files are provided under a Creative Commons Attribution 4.0 International License. \n\n```\n        80s UK 001.wav\n        80s UK 002.wav\n        80s US 001.wav\n        80s US 002.wav\n        Modern UK 001.wav  \n        Modern UK 002.wav\n        Modern US 001.wav\n        Modern US 002.wav\n        Modern US 003.wav  \n        Modern US 004.wav  \n        Radio 001.wav  \n        Speaker 001.wav  \n        Speaker 002.wav  \n        Vintage UK 001.wav\n        Vintage UK 002.wav\n        Vintage US 001.wav\n        Vintage US 002.wav\n```\n\nSource: https://www.adventurekid.se/akrt/free-reverb-impulse-responses/\n\nCopyright © Adventure Kid Research &amp; Technology, Kristoffer Ekstrand.\n\nThese works are provided under a Creative Commons Attribution 4.0 International Public License.\n\nSee the full text of the Creative Commons Attribution 4.0 International Public License given below for Disclaimers of Warrantees and \nLimitations of Liability that apply to these works.");
        extensions({"http://lv2plug.in/ns/ext/worker#interface","http://lv2plug.in/ns/ext/state#interface"});
        ports({
            Lv2PortInfo_Init {
                .index_ = 0,
                .symbol_ = "reverb_mix",
                .name_ = "Volume",
                .min_value_ = -40,
                .max_value_ = 20,
                .default_value_ = -10,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{-40,"-INF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-cab-ir#impulseFile1Group",
                .units_ = Lv2Units::db,
                .comment_ = "Volume for impulse file #1.",
            },
            Lv2PortInfo_Init {
                .index_ = 1,
                .symbol_ = "reverb_mix2",
                .name_ = "Volume",
                .min_value_ = -40,
                .max_value_ = 20,
                .default_value_ = -10,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{-40,"-INF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-cab-ir#impulseFile2Group",
                .units_ = Lv2Units::db,
                .comment_ = "Volume for impulse file #2.",
            },
            Lv2PortInfo_Init {
                .index_ = 2,
                .symbol_ = "reverb_mix3",
                .name_ = "Volume",
                .min_value_ = -40,
                .max_value_ = 20,
                .default_value_ = -10,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{-40,"-INF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-cab-ir#impulseFile3Group",
                .units_ = Lv2Units::db,
                .comment_ = "Volume for impulse file #3.",
            },
            Lv2PortInfo_Init {
                .index_ = 3,
                .symbol_ = "time",
                .name_ = "Max T",
                .min_value_ = 0.100000001490116,
                .max_value_ = 10,
                .default_value_ = 1.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .is_logarithmic_ = true,
                .units_ = Lv2Units::s,
                .comment_ = "Maximum length of impulse data to use.",
            },
            Lv2PortInfo_Init {
                .index_ = 4,
                .symbol_ = "direct_mix",
                .name_ = "Direct",
                .min_value_ = -40,
                .max_value_ = 20,
                .default_value_ = -40,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{-40,"-INF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Direct mix. Set to minimum to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 5,
                .symbol_ = "predelay",
                .name_ = "Predelay",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{0,"Remove"},Lv2ScalePoint{1,"Keep"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .enumeration_property_ = true,
                .not_on_gui_ = true,
                .comment_ = "Removes leading silence in impulse when set to false.",
            },
            Lv2PortInfo_Init {
                .index_ = 6,
                .symbol_ = "loading_state",
                .name_ = "Status",
                .max_value_ = 5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .scale_points_ = {Lv2ScalePoint{0,"Not loaded"},Lv2ScalePoint{1,"Ready"},Lv2ScalePoint{2,"Error"},Lv2ScalePoint{3,"Loading"},Lv2ScalePoint{4,"Loading"},Lv2ScalePoint{5,"Loading"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .enumeration_property_ = true,
                .comment_ = "Plugin status.",
            },
            Lv2PortInfo_Init {
                .index_ = 7,
                .symbol_ = "in",
                .name_ = "In",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 8,
                .symbol_ = "out",
                .name_ = "Out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 9,
                .symbol_ = "control",
                .name_ = "Control",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Control",
            },
            Lv2PortInfo_Init {
                .index_ = 10,
                .symbol_ = "notify",
                .name_ = "Notify",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Notification",
            },
        });
        port_groups({Lv2PortGroup{"http://two-play.com/plugins/toob-cab-ir#impulseFile1Group","impulse1","Impulse Response 1"},Lv2PortGroup{"http://two-play.com/plugins/toob-cab-ir#impulseFile2Group","impulse2","Impulse Response 2"},Lv2PortGroup{"http://two-play.com/plugins/toob-cab-ir#impulseFile3Group","impulse3","Impulse Response 3"}});
        has_factory_presets(false);
        piPedalUI(PiPedalUI{
            {
                UiFileProperty_Init{
                    .label_ = "Impulse File",
                    .index_ = 0,
                    .directory_ = "CabIR",
                    .resourceDirectory_ = "impulseFiles/CabIR",
                    .fileTypes_ = {UiFileType{"WAV File","audio/wav",".wav"}},
                    .patchProperty_ = "http://two-play.com/plugins/toob-cab-ir#impulseFile2",
                    .portGroup_ = "http://two-play.com/plugins/toob-cab-ir#impulseFile2Group",
                },
                UiFileProperty_Init{
                    .label_ = "Impulse File",
                    .index_ = 0,
                    .directory_ = "CabIR",
                    .resourceDirectory_ = "impulseFiles/CabIR",
                    .fileTypes_ = {UiFileType{"WAV File","audio/wav",".wav"}},
                    .patchProperty_ = "http://two-play.com/plugins/toob-cab-ir#impulseFile",
                    .portGroup_ = "http://two-play.com/plugins/toob-cab-ir#impulseFile1Group",
                },
                UiFileProperty_Init{
                    .label_ = "Impulse File",
                    .index_ = 0,
                    .directory_ = "CabIR",
                    .resourceDirectory_ = "impulseFiles/CabIR",
                    .fileTypes_ = {UiFileType{"FLAC File","audio/flac",".flac"},UiFileType{"WAV File","audio/wav",".wav"}},
                    .patchProperty_ = "http://two-play.com/plugins/toob-cab-ir#impulseFile3",
                    .portGroup_ = "http://two-play.com/plugins/toob-cab-ir#impulseFile3Group",
                },
            },
            {
            },
            {
            }
        });
    }
};
#endif
