// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

class CabSimPluginInfo: public lv2c::ui::Lv2PluginInfo{
public:
    static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-cab-sim-ui";
    using super=lv2c::ui::Lv2PluginInfo;
    using ptr=std::shared_ptr<CabSimPluginInfo>;
    static ptr Create() { return std::make_shared<CabSimPluginInfo>(); }

    CabSimPluginInfo() {
        using namespace lv2c::ui;

        uri("http://two-play.com/plugins/toob-cab-sim");
        name("TooB Cab Simulator");
        brand("TooB");
        label("TooB CabSim");
        plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
        supported_features({"http://lv2plug.in/ns/lv2core#hardRTCapable","http://lv2plug.in/ns/ext/urid#map"});
        required_features({"http://lv2plug.in/ns/ext/urid#map"});
        optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
        author_name("Robin Davies");
        author_homepage("https://github.com/sponsors/rerdavies");
        comment("TooB Cab Simulator provides EQ tools for emulating cabinet response without incurring the heavy cost of \nimpulse-response based cabinet simulators. \n\nSee the plugin's presets for emulations of well-known cabinets. ");
        extensions({});
        ports({
            Lv2PortInfo_Init {
                .index_ = 0,
                .symbol_ = "locut",
                .name_ = "Lo Cut",
                .min_value_ = 30,
                .max_value_ = 300,
                .default_value_ = 83,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{30,"Off"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::hz,
                .comment_ = "Low cutoff frequency. Set to minimum to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 1,
                .symbol_ = "bright",
                .name_ = "Bright",
                .max_value_ = 20,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{0,"Off"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Bright filter boost. Set to minimum to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 2,
                .symbol_ = "brightf",
                .name_ = "BrightF",
                .min_value_ = 1000,
                .max_value_ = 5000,
                .default_value_ = 1300,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .designation_ = "http://lv2plug.in/ns/ext/parameters#cutoffFrequency",
                .units_ = Lv2Units::hz,
                .comment_ = "Bright filter cutoff frequency.",
            },
            Lv2PortInfo_Init {
                .index_ = 3,
                .symbol_ = "hicut",
                .name_ = "Hi Cut",
                .min_value_ = 2000,
                .max_value_ = 13000,
                .default_value_ = 6000,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{13000,"Off"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .is_logarithmic_ = true,
                .designation_ = "http://lv2plug.in/ns/ext/parameters#cutoffFrequency",
                .units_ = Lv2Units::hz,
                .comment_ = "Hi cutoff frequency. Set to maximum to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 4,
                .symbol_ = "comb",
                .name_ = "Comb",
                .default_value_ = 0.319999992847443,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .comment_ = "Amount of comb filtering. Set to minimum to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 5,
                .symbol_ = "combf",
                .name_ = "Comb F",
                .min_value_ = 1000,
                .max_value_ = 10000,
                .default_value_ = 8000,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .designation_ = "http://lv2plug.in/ns/ext/parameters#cutoffFrequency",
                .units_ = Lv2Units::hz,
                .comment_ = "Comb filter notch frequency.",
            },
            Lv2PortInfo_Init {
                .index_ = 6,
                .symbol_ = "trim",
                .name_ = "Trim",
                .min_value_ = -30,
                .max_value_ = 30,
                .default_value_ = 1.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Output leveltrim.",
            },
            Lv2PortInfo_Init {
                .index_ = 7,
                .symbol_ = "in",
                .name_ = "In",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 8,
                .symbol_ = "out",
                .name_ = "Out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 9,
                .symbol_ = "control",
                .name_ = "Control",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
            Lv2PortInfo_Init {
                .index_ = 10,
                .symbol_ = "notify",
                .name_ = "Notify",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
        });
        port_groups({});
        has_factory_presets(true);
        piPedalUI(PiPedalUI{
            {
            },
            {
                UiFrequencyPlot_Init {
                    .patchProperty_ = "http://two-play.com/plugins/toob#frequencyResponseVector",
                    .index_ = 0,
                    .xLeft_ = 30,
                    .xRight_ = 22050,
                    .yTop_ = 10,
                    .yBottom_ = -35,
                    .width_ = 236,
                },
            },
            {
            }
        });
    }
};
#endif
