// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

class ConvolutionReverbInfo: public lv2c::ui::Lv2PluginInfo{
public:
    static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-convolution-reverb-ui";
    using super=lv2c::ui::Lv2PluginInfo;
    using ptr=std::shared_ptr<ConvolutionReverbInfo>;
    static ptr Create() { return std::make_shared<ConvolutionReverbInfo>(); }

    ConvolutionReverbInfo() {
        using namespace lv2c::ui;

        uri("http://two-play.com/plugins/toob-convolution-reverb");
        name("TooB Convolution Reverb");
        brand("TooB");
        label("TooB CReverb");
        plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
        supported_features({"http://lv2plug.in/ns/ext/state#makePath","http://lv2plug.in/ns/ext/urid#map","http://lv2plug.in/ns/lv2core#hardRTCapable","http://lv2plug.in/ns/ext/state#mapPath","http://lv2plug.in/ns/ext/state#:freePath","http://lv2plug.in/ns/ext/worker#schedule"});
        required_features({"http://lv2plug.in/ns/ext/urid#map"});
        optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable","http://lv2plug.in/ns/ext/state#:freePath","http://lv2plug.in/ns/ext/worker#schedule","http://lv2plug.in/ns/ext/state#makePath","http://lv2plug.in/ns/ext/state#mapPath"});
        author_name("Robin Davies");
        author_homepage("https://github.com/sponsors/rerdavies");
        comment("Convolution reverb is a notoriously compute-intensive effect. If you are having performance issues,  use the Max T control to constrain the length of the impulse file to\nunder two seconds. \n\nThe Max T control affects how much of the impulse file is used. If the length of the impulse file is longer than the specified time, samples occurring after \nthe specified time are discarded, and the tail of the impulse convolution is fed back into the input of the convolution. This ensures a smooth reverb tail, \nand has little effect on the quality of the resulting reverb. If the impulse file is shorter than the specified time, then all samples in the impulse \nfile are used, and no feedback occurs. You can often get smooth reverbs that preserve most of the character of the impulse file with Max T set to \n250ms or less.\n\nBecause reverb impulse files often include the original sound, you will sometimes get strange comb filter effects if you use the Direct mix control;\nbut this varies depending on the impulse file in question. Usually, the Direct mix control should be set to -INF.\n\nThe Predelay control determines whether Toob Convolution Reverb will strip leading silence from the impulse data. Turning it on preserves leading silence in the\nimpulse signal; turning it off removes leading silence. If the the Direct mix control is set to -INF dB, there's no real point in \ndelaying the convolution reverb output; you want responses as quickly as possible. The Predelay control should be set to off.\n The leading silence in impulse files can sometimes be quite significant. \n\nIf the impulse file has 4 channels, Toob Convolution Reverb assumes the signal is in Ambisonic b-format, and down-mixes the ambisonic channels to mono. To generate\nstereo reverb effects from ambisonic audio, use the stereo version of this plugin.\n\nToob Convolution Reverb comes with a nominal set of reverb impulse files to get you started. You are strongly encouraged to explore the rich collections of\nreverb impulse files that are widely available on the internet. \n\nSpecial thanks are extended to the the OpenAir project, which graciously provided the base set of impulse files\ndistributed with Toob Convolution Reverb under licensing terms that are compatible with the Toob Amp project's\nlicensing terms.\n\n---\n\nToob Convolution Reverb's impulse files were provided by the OpenAir project \n(https://www.openair.hosted.york.ac.uk) under CC-By-4.0 licenses. \n\nSee the full text of the Creative Commons Attribution 4.0 International Public License given below for Disclaimers of Warrantees and \nLimitations of Liability that apply to these works.\n\n##### Arthur Sykes Rymer Auditorium.wav\n\nCopyright © www.openairlib.net, University of York\n\nThis work is provided under a Creative Commons Attribution 4.0 International Public License.\n\nhttps://creativecommons.org/licenses/by/4.0/\n\nSource: https://www.openair.hosted.york.ac.uk/?page_id=425\n\n\n##### Jack Lyons Hall, University of York.wav\n\nCopyright © www.openairlib.net, Audiolab University of York, Alex Duffell, Aishwarya Sridhar, Zhong Li\n\nThis work is provided under a Creative Commons Attribution 4.0 International Public License.\n\nhttps://creativecommons.org/licenses/by/4.0/\n\nSource: https://www.openair.hosted.york.ac.uk/?page_id=571\n\n\n\n##### Koli National Park - Winter.wav\n\nCopyright © www.openairlib.net, Audio Lab University of York, Andrew Chadwick, Simon Shelley\n\nThis work is provided under a Creative Commons Attribution 4.0 International Public License.\n\nhttps://creativecommons.org/licenses/by/4.0/\n\nSource: https://www.openair.hosted.york.ac.uk/?page_id=584\n\n\n\n##### St. Margaret’s Church.wav\n\nCopyright © www.openairlib.net, AudioLab University of York, www.ncem.co.uk\n\nThis work is provided under a Creative Commons Attribution 4.0 International Public License.\n\nhttps://creativecommons.org/licenses/by/4.0/\n\nSource: https://www.openair.hosted.york.ac.uk/?page_id=702\n\n\n##### Genesis 6 Studio Live Room.wav\n\nCopyright © www.openairlib.net\n\nThis work is provided under a Creative Commons Attribution 4.0 International Public License.\n\nhttps://creativecommons.org/licenses/by/4.0/\n\nSource: https://www.openair.hosted.york.ac.uk/?page_id=483");
        extensions({"http://lv2plug.in/ns/ext/worker#interface","http://lv2plug.in/ns/ext/state#interface"});
        ports({
            Lv2PortInfo_Init {
                .index_ = 0,
                .symbol_ = "time",
                .name_ = "Max T",
                .min_value_ = 0.100000001490116,
                .max_value_ = 10,
                .default_value_ = 1.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .is_logarithmic_ = true,
                .units_ = Lv2Units::s,
                .comment_ = "Maximum length of impulse data to use.",
            },
            Lv2PortInfo_Init {
                .index_ = 1,
                .symbol_ = "direct_mix",
                .name_ = "Direct",
                .min_value_ = -40,
                .max_value_ = 20,
                .default_value_ = -40,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{-40,"-INF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Direct mix. Set to minimum to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 2,
                .symbol_ = "reverb_mix",
                .name_ = "Reverb",
                .min_value_ = -40,
                .max_value_ = 20,
                .default_value_ = -10,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{-40,"-INF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Reverb mix. Set to minimum to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 3,
                .symbol_ = "predelay",
                .name_ = "Predelay",
                .default_value_ = 1,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{0,"Remove"},Lv2ScalePoint{1,"Keep"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .enumeration_property_ = true,
                .comment_ = "Removes leading silence in impulse when set to false.",
            },
            Lv2PortInfo_Init {
                .index_ = 4,
                .symbol_ = "loading_state",
                .name_ = "Status",
                .max_value_ = 5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .scale_points_ = {Lv2ScalePoint{0,"Not loaded"},Lv2ScalePoint{1,"Ready"},Lv2ScalePoint{2,"Error"},Lv2ScalePoint{3,"Loading"},Lv2ScalePoint{4,"Loading"},Lv2ScalePoint{5,"Loading"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .enumeration_property_ = true,
                .comment_ = "Plugin status.",
            },
            Lv2PortInfo_Init {
                .index_ = 5,
                .symbol_ = "in",
                .name_ = "In",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 6,
                .symbol_ = "out",
                .name_ = "Out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 7,
                .symbol_ = "control",
                .name_ = "Control",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Control",
            },
            Lv2PortInfo_Init {
                .index_ = 8,
                .symbol_ = "notify",
                .name_ = "Notify",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Notification",
            },
        });
        port_groups({});
        has_factory_presets(true);
        piPedalUI(PiPedalUI{
            {
                UiFileProperty_Init{
                    .label_ = "Reverb Impulse File",
                    .index_ = 3,
                    .directory_ = "ReverbImpulseFiles",
                    .resourceDirectory_ = "impulseFiles/reverb",
                    .fileTypes_ = {UiFileType{"WAV files","audio/wav",".wav"},UiFileType{"FLAC files","audio/flac",".flac"}},
                    .patchProperty_ = "http://two-play.com/plugins/toob-impulse#impulseFile",
                },
            },
            {
            },
            {
            }
        });
    }
};
#endif
