// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

class InputStagePluginInfo: public lv2c::ui::Lv2PluginInfo{
public:
    static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-input_stage-ui";
    using super=lv2c::ui::Lv2PluginInfo;
    using ptr=std::shared_ptr<InputStagePluginInfo>;
    static ptr Create() { return std::make_shared<InputStagePluginInfo>(); }

    InputStagePluginInfo() {
        using namespace lv2c::ui;

        uri("http://two-play.com/plugins/toob-input_stage");
        name("TooB Input Stage");
        brand("TooB");
        label("TooB Input");
        plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
        supported_features({"http://lv2plug.in/ns/lv2core#hardRTCapable","http://lv2plug.in/ns/ext/urid#map"});
        required_features({"http://lv2plug.in/ns/ext/urid#map"});
        optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
        author_name("Robin Davies");
        author_homepage("https://github.com/sponsors/rerdavies");
        comment("The TooB Input Stage provides basic tools for trimming and shaping guitar input signals\nbefore feeding them through amp emulations. Typically it should be placed as the \nfirst effect in a guitar signal chain.\n\nAmp emulations expect guitar signal levels to be nominally close \nto zero db. Use the Trim control to get your input signal into a reasonable range (ideally, into\nthe yellow range on the VU, but not going above zero dB).\n\nIn some cases, you can reduce noise in your guitar signal by filtering out low and high frequencies.\nUse the Low and Hi Cut controls to remove unnecessary frequencies. Set the Lo Cut to minimum value\nto disable the Low Cut filter. Set the Hi Cut control to maximum value to disable the Hi Cut filter.\n\nBright EQ settings allow boosting of high frequencies to simulate the bright input jack\nfound on many guitar amps. \n\nThe GateT control provides a noise gate. Set to minimum value to disable.");
        extensions({});
        ports({
            Lv2PortInfo_Init {
                .index_ = 0,
                .symbol_ = "trim",
                .name_ = "Trim",
                .min_value_ = -60,
                .max_value_ = 30,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{-60,"-INF"},Lv2ScalePoint{20,"+30dB"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Input level trim",
            },
            Lv2PortInfo_Init {
                .index_ = 1,
                .symbol_ = "trimOut",
                .min_value_ = -35,
                .max_value_ = 10,
                .default_value_ = -35,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
            },
            Lv2PortInfo_Init {
                .index_ = 2,
                .symbol_ = "gate_t",
                .name_ = "Gate T",
                .min_value_ = -80,
                .max_value_ = -20,
                .default_value_ = -80,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{-80,"OFF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Noise gate threshold. Zero to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 3,
                .symbol_ = "gate_out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .integer_property_ = true,
                .toggled_property_ = true,
                .comment_ = "Noise gate",
            },
            Lv2PortInfo_Init {
                .index_ = 4,
                .symbol_ = "locut",
                .name_ = "Lo Cut",
                .min_value_ = 30,
                .max_value_ = 300,
                .default_value_ = 60,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{30,"OFF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-input_stage#filterGroup",
                .designation_ = "http://lv2plug.in/ns/ext/parameters#cutoffFrequency",
                .units_ = Lv2Units::hz,
                .comment_ = "Low cutoff frequency",
            },
            Lv2PortInfo_Init {
                .index_ = 5,
                .symbol_ = "bright",
                .name_ = "Bright",
                .max_value_ = 25,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{0,"OFF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-input_stage#filterGroup",
                .units_ = Lv2Units::db,
                .comment_ = "High frequency boost. Zero to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 6,
                .symbol_ = "brightf",
                .name_ = "Bright F",
                .min_value_ = 1000,
                .max_value_ = 5000,
                .default_value_ = 1300,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{0,"OFF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-input_stage#filterGroup",
                .designation_ = "http://lv2plug.in/ns/ext/parameters#cutoffFrequency",
                .units_ = Lv2Units::hz,
                .comment_ = "Bright cutoff frequency.",
            },
            Lv2PortInfo_Init {
                .index_ = 7,
                .symbol_ = "hicut",
                .name_ = "Hi Cut",
                .min_value_ = 2000,
                .max_value_ = 13000,
                .default_value_ = 13000,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{13000,"OFF"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .is_logarithmic_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-input_stage#filterGroup",
                .designation_ = "http://lv2plug.in/ns/ext/parameters#cutoffFrequency",
                .units_ = Lv2Units::hz,
                .comment_ = "Hi cutoff frequency.",
            },
            Lv2PortInfo_Init {
                .index_ = 8,
                .symbol_ = "in",
                .name_ = "In",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 9,
                .symbol_ = "out",
                .name_ = "Out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 10,
                .symbol_ = "control",
                .name_ = "Control",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
            Lv2PortInfo_Init {
                .index_ = 11,
                .symbol_ = "notify",
                .name_ = "Notify",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
        });
        port_groups({Lv2PortGroup{"http://two-play.com/plugins/toob-input_stage#filterGroup","filter","EQ"}});
        has_factory_presets(false);
        piPedalUI(PiPedalUI{
            {
            },
            {
                UiFrequencyPlot_Init {
                    .patchProperty_ = "http://two-play.com/plugins/toob#frequencyResponseVector",
                    .index_ = 99,
                    .portGroup_ = "http://two-play.com/plugins/toob-input_stage#filterGroup",
                    .xLeft_ = 30,
                    .xRight_ = 22050,
                    .yTop_ = 10,
                    .yBottom_ = -35,
                    .width_ = 160,
                },
            },
            {
            }
        });
    }
};
#endif
