// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

class SpectrumAnalyzerInfo: public lv2c::ui::Lv2PluginInfo{
public:
    static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-spectrum-ui";
    using super=lv2c::ui::Lv2PluginInfo;
    using ptr=std::shared_ptr<SpectrumAnalyzerInfo>;
    static ptr Create() { return std::make_shared<SpectrumAnalyzerInfo>(); }

    SpectrumAnalyzerInfo() {
        using namespace lv2c::ui;

        uri("http://two-play.com/plugins/toob-spectrum");
        name("TooB Spectrum Analyzer");
        brand("TooB");
        label("Spectrum Analyzer");
        plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
        supported_features({"http://lv2plug.in/ns/ext/worker#schedule","http://lv2plug.in/ns/lv2core#hardRTCapable","http://lv2plug.in/ns/ext/urid#map"});
        required_features({"http://lv2plug.in/ns/ext/urid#map","http://lv2plug.in/ns/ext/worker#schedule"});
        optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
        author_name("Robin Davies");
        author_homepage("https://github.com/sponsors/rerdavies");
        comment("TooB spectrum analyzer");
        extensions({"http://lv2plug.in/ns/ext/state#interface","http://lv2plug.in/ns/ext/worker#interface"});
        ports({
            Lv2PortInfo_Init {
                .index_ = 0,
                .symbol_ = "in",
                .name_ = "In",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 1,
                .symbol_ = "out",
                .name_ = "Out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 2,
                .symbol_ = "control",
                .name_ = "Control",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
            Lv2PortInfo_Init {
                .index_ = 3,
                .symbol_ = "notify",
                .name_ = "Notify",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
            Lv2PortInfo_Init {
                .index_ = 4,
                .symbol_ = "minF",
                .name_ = "Min F",
                .min_value_ = 10,
                .max_value_ = 400,
                .default_value_ = 60,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::hz,
                .comment_ = "Minimum frequency displayed.",
            },
            Lv2PortInfo_Init {
                .index_ = 5,
                .symbol_ = "maxF",
                .name_ = "Max F",
                .min_value_ = 1000,
                .max_value_ = 22000,
                .default_value_ = 22000,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::hz,
                .comment_ = "Maximum frequency displayed.",
            },
            Lv2PortInfo_Init {
                .index_ = 6,
                .symbol_ = "level",
                .name_ = "Level",
                .min_value_ = -30,
                .max_value_ = 30,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Display level",
            },
        });
        port_groups({});
        has_factory_presets(false);
        piPedalUI(PiPedalUI{
            {
            },
            {
            },
            {
            }
        });
    }
};
#endif
