// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

class Tf2FlangerStereoPluginInfo: public lv2c::ui::Lv2PluginInfo{
public:
    static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-flanger-stereo-ui";
    using super=lv2c::ui::Lv2PluginInfo;
    using ptr=std::shared_ptr<Tf2FlangerStereoPluginInfo>;
    static ptr Create() { return std::make_shared<Tf2FlangerStereoPluginInfo>(); }

    Tf2FlangerStereoPluginInfo() {
        using namespace lv2c::ui;

        uri("http://two-play.com/plugins/toob-flanger-stereo");
        name("TooB BF-2 Stereo Flanger");
        brand("TooB");
        label("TooB BF-2 Stereo");
        plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
        supported_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
        required_features({});
        optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
        author_name("Robin Davies");
        author_homepage("https://github.com/sponsors/rerdavies");
        comment("Digital emulation of a Boss BF-2 Flanger.\n\nNote: use of this plugin in monophonic signal chains, on some hosts, may completely cancel out the flanger effect, since the right channel is \ncreated by subtracting the output of the flanger delay line instead of adding it. If you are using this effect in a monophonic effect chain, you \nshould use the monophonic version of this effect.");
        extensions({});
        ports({
            Lv2PortInfo_Init {
                .index_ = 0,
                .symbol_ = "manual",
                .name_ = "Manual",
                .default_value_ = 0.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#InputPort","http://lv2plug.in/ns/lv2core#ControlPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .comment_ = "Maximum delay excursion",
            },
            Lv2PortInfo_Init {
                .index_ = 1,
                .symbol_ = "depth",
                .name_ = "Depth",
                .default_value_ = 0.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .comment_ = "LFO depth",
            },
            Lv2PortInfo_Init {
                .index_ = 2,
                .symbol_ = "rate",
                .name_ = "Rate",
                .default_value_ = 0.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .comment_ = "LFO rate",
            },
            Lv2PortInfo_Init {
                .index_ = 3,
                .symbol_ = "lfo",
                .name_ = "LFO",
                .min_value_ = -1,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .not_on_gui_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 4,
                .symbol_ = "res",
                .name_ = "Res",
                .default_value_ = 0.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .comment_ = "Delay feedback",
            },
            Lv2PortInfo_Init {
                .index_ = 5,
                .symbol_ = "in",
                .name_ = "In",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 6,
                .symbol_ = "outl",
                .name_ = "OutL",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 7,
                .symbol_ = "outr",
                .name_ = "OutR",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
        });
        port_groups({});
        has_factory_presets(true);
        piPedalUI(PiPedalUI{
            {
            },
            {
            },
            {
            }
        });
    }
};
#endif
