// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

namespace record_plugin{
    class ToobLooperFourUiBase: public lv2c::ui::Lv2PluginInfo{
    public:
        static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-looper-four-ui";
        using super=lv2c::ui::Lv2PluginInfo;
        using ptr=std::shared_ptr<ToobLooperFourUiBase>;
        static ptr Create() { return std::make_shared<ToobLooperFourUiBase>(); }

        ToobLooperFourUiBase() {
            using namespace lv2c::ui;

            uri("http://two-play.com/plugins/toob-looper-four");
            name("TooB 4Looper (stereo)");
            brand("TooB");
            label("4Looper");
            plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
            supported_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            required_features({});
            optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            author_name("Robin Davies");
            author_homepage("https://github.com/sponsors/rerdavies");
            comment("## Toob 4Looper\n\nA 4-channel looper. If you are using a MIDI foot controller, you may want to consider using Toob One-Control looper, which allows control of \nlooping using a single footswitch. TooB 4Looper does support MIDI control using four footswitches. See the Midi Operation section below for\nmore information. \n\n### Basic Operation\n\nYou must record a main loop before loops 2 through 4 are available. \n\nTo start recording the main loop, press the Main Loop record button. The red Record LED will light up to indicate that the main loop is recording.\nYou can configure TooB 4Looper to use a variable length main loop, or a fixed length loop. See the documentation on the Bars control for more \ninformation on how to use a fixed-length loop. If the Bars control is set to \"Free\", the length of the main loop will be established when \nyou next press the Record or Play button after the main loop has started recording. Pressing the record button will mark the end of the \nloop, and continue on in Overdub mode. Pressing the Play button will mark the end of the loop, and start playback. \n\nOnce the main loop has been established, you can toggle back and forth between Overdub and Play modes by pressing the Record and Play buttons \nresepectively. \n\nYou can also mute the loop by going to Play mode, and pushing the Play button once more. Pushing the Play button while in Mute mode will \nre-enable audio output from the loop. \n\nPressing the Main Loop stop buton will stop playback of of all loops, and return the looper to its initial state.\n\nTo record a secondary loop, press the Record button for the loop you want to record. The Record LED will light up to indicate that the loop \nis recording. If the Rec Sync option is enabled, the loop will go to Cue Overdub mode, and once the main loop reaches the end of its loop, \nthe loop will switch to Record mode. If the Rec Sync option is disabled, the loop will start recording immediately. The length of secondary \nloops will always be the same as the length of the main loop. Once the loop has started, pressing the play button will start playback. \nPressing the record button will overdub content of the loop. In Play mode, pushing the Play button again will mute the loop. Pressing \nthe Play button when the loop is muted will re-enable audio output from the loop. Pressing the Stop button will stop playback, and erase\nthe contents of the loop. There is no concept of \"undoing\" individual overdubs in TooB 4Looper. If you're done with a loop, just erase it.\n\n### Clock Options\n\nClock options determine the tempo and number of beats in a bar. They affect the behavior of the looper when the Bars control (see below) is set to \na numeric value, and also affect the rate and pattern of the flashing LEDs when counting in. \n\n### Record Options\n\nRecord Options control the behavior of the looper.  \n\nThe Rec Start control determines when recording start. If set to Immediate, the looper will start recording as soon as you tap the Record button. \nWhen set to Count In, after tapping the Record button, the main loop will count in before it starts recording. The Record LED will flash when counting in, and go solid \nonce recording starts. The pattern of blinking lights depends on the TimeSig setting, so for example, if the Time Signature is set to 4/4, the \nblinking LED will signal a count-in pattern of \"1 - 2 - 1 2 3 4\". Secondary loops start overdubbing immediately, unless the Rec Sync button \nis enabled.  When set to Trigger, after pressing the Record button, the looper will not start recording until it detects a signal \non audio input. The Trig Lvl control sets how loud the signal must be in order to start recording. \n\n\nWhen Bars is set to Free (the minimum value), the length of the main loop will be set by a second tap of the \nControl button after recording of the main loop starts. If Bars is set to a numeric value, the length of the main loop will be determined by the number \nof bars set in the Bars control, and the current settings of the Clock controls. \n\nIf Dub Sync is off, overdubs will start recording as soon as you tap the Control button. If enabled, the start \nof the secondary loop will sync with main loop. Tapping the Control button will put the looper in \"Cue Overdub\" state\nand the LEDs will flash until the end of the main loop is reached, at which point the new loop will start recording. \n\nThe Loop End option only has effect when the Bars control is set to a numeric value, and does nothing if Bars is set to \"Free\". \nWhen set to REC-PLAY, the main loop will record exactly N bars of audio, and switch to play mode when the end of the loop is reached. \nWhen set to REC-DUB, the main loop will record exactly N bars of audio, and then continue on in overdub mode. \n\n\n### MIDI Operation\n\nIf you want to control your looper with one foot controller switch, please use Toob One-Control Looper instead. Toob 4Looper \nallows you to control loops with four foot controller switches (one for each loop). In order to do this, TooB 4Looper provides \na hidden controls only visible in PiPedal's MIDI Bindings user-interface. The hidden controls are named `Midi CTL`; there's one \ncontrol for each loop. A single tap of the control will cause the loop to start  \nrecording or playing or overdubbing, depending on the state of the loop. Long-pressing the control will erase the loop. Erasing the main loop\nwill stop all playback, erasing all other loops as well, and return the Toob 4Looper to its initial state. \n\nTo use the hidden controls, you must bind each of them to your MIDI controller's footswitches. It is recommended that you configure\nyour MIDI controller to send MIDI Note-on/Note off messages. You can bind the controls to MIDI CC messages as well, but the behavior\nof your controller may not match what TooB 4Looper expects. If you must use MIDI CC messages, you should configure your MIDI \ncontroller to set a CC value of zero when not pressed, and a value of 127 when pressed, and adjust PiPedal's MIDI bindings appropriately.\n\nThe following state table controls how the hidden controls operate. Each loop has an independent state. \n\n### State Table for Looop Operations\n\nThe following table describes state transitions for each loop. Note that loops 2 to 4 are not available until the main loop has been recorded. The\nThe Control Tap and Long Press actions are generated by hidden `Midi CTL` controls.\n\n```\n+-----------+--------------+----------------------------------+\n| State     | Action       | Effect                           |\n|-----------|--------------|----------------------------------|\n| Empty     | Record /     | Start recording immeediately if  |\n|           | Control Tap  | the Rec Start control is set to  |\n|           |              | Immediately. If set to Count In, |\n|           |              | go to Count-In state. If set to  |\n|           |              | Trigger, go to Trigger state.    |\n|-----------|--------------|----------------------------------|\n| Trigger   | Stop /       | Return to empty state            |\n|           | Long-press / |                                  |\n|           | Control Tap  |                                  | \n|           |              |                                  |\n|           | Input signal | Start recording                  |\n|           | detected     |                                  |\n|-----------|--------------|----------------------------------|\n| Count-In  | Stop /       | Return to empty state            |\n|           | Long-press / |                                  |\n|           | Control Tap  |                                  | \n|           |              |                                  |\n|           | Complete     | Start recording                  |\n|-----------|--------------|----------------------------------|\n| Recording | Play /       | Set the loop length (main loop   |\n|           | Control Tap  | only_) and go to play state .    |\n|           |              |                                  |\n|           | Record       | Set the loop length (main loop   |\n|           |              | only_) and go to Overdub state . |\n|           |              |                                  |\n|           | Stop/        | Discard the current loop and     |\n|           | Long-Press   | return to Empty state            |\n|           |              |                                  |\n|           | End of loop  | go to play or overdub state      |\n|           |              | depending on ON REC END          |\n|           |              | (main loop only)                 |\n|-----------|--------------|----------------------------------|\n| Playing   | Record /     | If DUB SYNC is on, go to         |\n|           | Control Tap  | Cue Ovdb state; otherwise        |\n|           |              | start overdubbing immediately.   |\n|           |              |                                  |\n|           | Play         | Mute the loop, and go to Mute    |\n|           |              | state.                           |\n|           |              |                                  |\n|           | Stop /       | Discard the current loop and go  |\n|           | Long-press   | to Empty state.                  |\n|-----------|--------------|----------------------------------|\n| Mute      | Play / Tap   | Unmute the loop and go to Play   |\n|           |              | state.                           |\n|           |              |                                  |\n|           | Record       | Start overdubbing.               |\n|           |              |                                  |\n|           | Stop /       | Discard the current loop and go  |\n|           | Long-press   | to Empty state.                  |\n|-----------|--------------|----------------------------------|\n| Cue Ovdb  | End-of-loop  | Start overdubbing.               |\n|           |              |                                  |\n|           | Tap          | Cancel the pending overdub.      |      \n|           |              |                                  |\n|           | Long-press   | Discard the current loop and go  |\n|           |              | to Empty state.                  |\n|-----------|--------------|----------------------------------|\n| Overdub   | Play / Tap   | Start playing.                   |\n|           |              |                                  |\n|           | End of loop  | (If DUB SYNC is on, and          |\n|           |              | REC->PLAY is selected) Go to     |\n|           |              | play state, otherwise, continue  |\n|           |              | in overdub state.                |\n+-----------|--------------|----------------------------------+\n```");
            extensions({"http://lv2plug.in/ns/ext/state#interface"});
            ports({
                Lv2PortInfo_Init {
                    .index_ = 0,
                    .symbol_ = "control1",
                    .name_ = "MIDI Ctl",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#InputPort","http://lv2plug.in/ns/lv2core#ControlPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .integer_property_ = true,
                    .mod_momentaryOffByDefault_ = true,
                    .toggled_property_ = true,
                    .not_on_gui_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop_main_group",
                    .comment_ = "Hidden control for MIDI operation. See documentation for details.",
                },
                Lv2PortInfo_Init {
                    .index_ = 1,
                    .symbol_ = "stop1",
                    .name_ = "⏹",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop_main_group",
                    .comment_ = "Reset all loops.",
                },
                Lv2PortInfo_Init {
                    .index_ = 2,
                    .symbol_ = "record1",
                    .name_ = "⏺",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop_main_group",
                    .comment_ = "Recording/overdub the main loop",
                },
                Lv2PortInfo_Init {
                    .index_ = 3,
                    .symbol_ = "record_led1",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop_main_group",
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 4,
                    .symbol_ = "play1",
                    .name_ = "⏵",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop_main_group",
                    .comment_ = "Play Loop 1. Click again to stop.",
                },
                Lv2PortInfo_Init {
                    .index_ = 5,
                    .symbol_ = "play_led1",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop_main_group",
                    .pipedal_ledColor_ = "green",
                },
                Lv2PortInfo_Init {
                    .index_ = 6,
                    .symbol_ = "position1",
                    .name_ = "    ",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop_main_group",
                    .units_ = Lv2Units::pc,
                    .comment_ = "Time",
                },
                Lv2PortInfo_Init {
                    .index_ = 7,
                    .symbol_ = "control2",
                    .name_ = "MIDI Ctl",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .integer_property_ = true,
                    .mod_momentaryOffByDefault_ = true,
                    .toggled_property_ = true,
                    .not_on_gui_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop2_group",
                    .comment_ = "Hidden control for MIDI operation. See documentation for details.",
                },
                Lv2PortInfo_Init {
                    .index_ = 8,
                    .symbol_ = "stop2",
                    .name_ = "⏹",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop2_group",
                    .comment_ = "Reset loop 2.",
                },
                Lv2PortInfo_Init {
                    .index_ = 9,
                    .symbol_ = "record2",
                    .name_ = "⏺",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#InputPort","http://lv2plug.in/ns/lv2core#ControlPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop2_group",
                    .comment_ = "Record/Overdub loop 2",
                },
                Lv2PortInfo_Init {
                    .index_ = 10,
                    .symbol_ = "record_led2",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop2_group",
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 11,
                    .symbol_ = "play2",
                    .name_ = "⏵",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop2_group",
                    .comment_ = "Play Loop 2. Click again to stop.",
                },
                Lv2PortInfo_Init {
                    .index_ = 12,
                    .symbol_ = "play_led2",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop2_group",
                    .pipedal_ledColor_ = "green",
                },
                Lv2PortInfo_Init {
                    .index_ = 13,
                    .symbol_ = "position2",
                    .name_ = "    ",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop2_group",
                    .units_ = Lv2Units::pc,
                    .comment_ = "Time",
                },
                Lv2PortInfo_Init {
                    .index_ = 14,
                    .symbol_ = "control3",
                    .name_ = "MIDI Ctl",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .integer_property_ = true,
                    .mod_momentaryOffByDefault_ = true,
                    .toggled_property_ = true,
                    .not_on_gui_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop3_group",
                    .comment_ = "Hidden control for MIDI operation. See documentation for details.",
                },
                Lv2PortInfo_Init {
                    .index_ = 15,
                    .symbol_ = "stop3",
                    .name_ = "⏹",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop3_group",
                    .comment_ = "Reset loop 3.",
                },
                Lv2PortInfo_Init {
                    .index_ = 16,
                    .symbol_ = "record3",
                    .name_ = "⏺",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop3_group",
                    .comment_ = "Record/Overdub loop 3",
                },
                Lv2PortInfo_Init {
                    .index_ = 17,
                    .symbol_ = "record_led3",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop3_group",
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 18,
                    .symbol_ = "play3",
                    .name_ = "⏵",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop3_group",
                    .comment_ = "Play Loop 3. Click again to stop.",
                },
                Lv2PortInfo_Init {
                    .index_ = 19,
                    .symbol_ = "play_led3",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop3_group",
                    .pipedal_ledColor_ = "green",
                },
                Lv2PortInfo_Init {
                    .index_ = 20,
                    .symbol_ = "position3",
                    .name_ = "    ",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop3_group",
                    .units_ = Lv2Units::pc,
                    .comment_ = "Time",
                },
                Lv2PortInfo_Init {
                    .index_ = 21,
                    .symbol_ = "control4",
                    .name_ = "Midi Ctl",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .integer_property_ = true,
                    .mod_momentaryOffByDefault_ = true,
                    .toggled_property_ = true,
                    .not_on_gui_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop4_group",
                    .comment_ = "Hidden control for MIDI operation. See documentation for details.",
                },
                Lv2PortInfo_Init {
                    .index_ = 22,
                    .symbol_ = "stop4",
                    .name_ = "⏹",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop4_group",
                    .comment_ = "Reset loop 4.",
                },
                Lv2PortInfo_Init {
                    .index_ = 23,
                    .symbol_ = "record4",
                    .name_ = "⏺",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop4_group",
                    .comment_ = "Record/Overdub loop 4",
                },
                Lv2PortInfo_Init {
                    .index_ = 24,
                    .symbol_ = "record_led4",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop4_group",
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 25,
                    .symbol_ = "play4",
                    .name_ = "⏵",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop4_group",
                    .comment_ = "Play Loop 4. Click again to stop.",
                },
                Lv2PortInfo_Init {
                    .index_ = 26,
                    .symbol_ = "play_led4",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop4_group",
                    .pipedal_ledColor_ = "green",
                },
                Lv2PortInfo_Init {
                    .index_ = 27,
                    .symbol_ = "position4",
                    .name_ = "    ",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#loop4_group",
                    .units_ = Lv2Units::pc,
                    .comment_ = "Time",
                },
                Lv2PortInfo_Init {
                    .index_ = 28,
                    .symbol_ = "bar_led",
                    .name_ = "  Bar  ",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#syncGroup",
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 29,
                    .symbol_ = "beat_led",
                    .name_ = " Beat ",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#syncGroup",
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 30,
                    .symbol_ = "tempo",
                    .name_ = "Tempo",
                    .min_value_ = 40,
                    .max_value_ = 240,
                    .default_value_ = 120,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#syncGroup",
                    .units_ = Lv2Units::bpm,
                    .comment_ = "Tempo in quarter-notes per minute",
                },
                Lv2PortInfo_Init {
                    .index_ = 31,
                    .symbol_ = "timesig",
                    .name_ = "TimeSig",
                    .max_value_ = 5,
                    .default_value_ = 2,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{0,"2/2"},Lv2ScalePoint{1,"3/4"},Lv2ScalePoint{2,"4/4"},Lv2ScalePoint{3,"5/4"},Lv2ScalePoint{4,"6/8"},Lv2ScalePoint{5,"7/4"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .enumeration_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#syncGroup",
                    .comment_ = "Time Signature",
                },
                Lv2PortInfo_Init {
                    .index_ = 32,
                    .symbol_ = "rec_count_in",
                    .name_ = "Rec Start",
                    .max_value_ = 2,
                    .default_value_ = 1,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#InputPort","http://lv2plug.in/ns/lv2core#ControlPort"}},
                    .scale_points_ = {Lv2ScalePoint{0,"Immediate"},Lv2ScalePoint{1,"Count in"},Lv2ScalePoint{2,"Trigger"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .enumeration_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#options_group",
                    .comment_ = "When to start recording.",
                },
                Lv2PortInfo_Init {
                    .index_ = 33,
                    .symbol_ = "trigger_level",
                    .name_ = "Trig Lvl",
                    .min_value_ = -60,
                    .max_value_ = 0,
                    .default_value_ = -25,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#options_group",
                    .units_ = Lv2Units::db,
                },
                Lv2PortInfo_Init {
                    .index_ = 34,
                    .symbol_ = "trigger_led",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#options_group",
                },
                Lv2PortInfo_Init {
                    .index_ = 35,
                    .symbol_ = "bars",
                    .name_ = "Bars",
                    .max_value_ = 32,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{0,"Free"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .integer_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#options_group",
                    .units_ = Lv2Units::bar,
                    .comment_ = "Loop length in bars. Set to minimum for arbitrary length loops.",
                },
                Lv2PortInfo_Init {
                    .index_ = 36,
                    .symbol_ = "rec_sync_option",
                    .name_ = "Rec Sync",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#options_group",
                    .comment_ = "Whether to sync the start of the loop with the main loop when recording secondary loops.",
                },
                Lv2PortInfo_Init {
                    .index_ = 37,
                    .symbol_ = "loop_end_option",
                    .name_ = "On Rec End",
                    .min_value_ = 1,
                    .max_value_ = 2,
                    .default_value_ = 1,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{1,"REC->PLAY"},Lv2ScalePoint{2,"REC->DUB"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .enumeration_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#options_group",
                    .comment_ = "(One-control MIDI operation only) Whether to go to OVERDUB or PLAY state when recording of the main loop ends.",
                },
                Lv2PortInfo_Init {
                    .index_ = 38,
                    .symbol_ = "level",
                    .name_ = "Level",
                    .min_value_ = -60,
                    .max_value_ = 30,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{-60,"-INF"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#output_group",
                    .units_ = Lv2Units::db,
                    .comment_ = "Trim output level",
                },
                Lv2PortInfo_Init {
                    .index_ = 39,
                    .symbol_ = "in",
                    .name_ = "In",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#stereoInGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#left",
                },
                Lv2PortInfo_Init {
                    .index_ = 40,
                    .symbol_ = "out",
                    .name_ = "Out",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#stereoOutGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#left",
                },
                Lv2PortInfo_Init {
                    .index_ = 41,
                    .symbol_ = "controlIn",
                    .name_ = "ControlIn",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_atom_port_ = true,
                    .buffer_type_ = Lv2BufferType::Sequence,
                },
                Lv2PortInfo_Init {
                    .index_ = 42,
                    .symbol_ = "controlOut",
                    .name_ = "ControlOut",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_atom_port_ = true,
                    .buffer_type_ = Lv2BufferType::Sequence,
                },
                Lv2PortInfo_Init {
                    .index_ = 43,
                    .symbol_ = "inR",
                    .name_ = "InR",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#stereoInGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#right",
                },
                Lv2PortInfo_Init {
                    .index_ = 44,
                    .symbol_ = "outR",
                    .name_ = "OutR",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-four#stereoOutGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#right",
                },
            });
            port_groups({Lv2PortGroup{"http://two-play.com/plugins/toob-looper-four#loop_main_group","loop_main_group","Main Loop"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-four#loop2_group","loop2_group","Loop 2"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-four#loop3_group","loop3_group","Loop 3"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-four#loop4_group","loop4_group","Loop 4"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-four#syncGroup","sync_g","Clock"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-four#options_group","options_group","Record Options"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-four#output_group","output_group","Output"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-four#stereoInGroup","in_g",""},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-four#stereoOutGroup","",""}});
            has_factory_presets(false);
            piPedalUI(PiPedalUI{
                {
                },
                {
                },
                {
                }
            });
        }
    };
} // namespace
#endif
#ifdef DEFINE_LV2_PLUGIN_BASE
#include <lv2_plugin/Lv2Plugin.hpp>
#include <lv2_plugin/Lv2Ports.hpp>
using namespace lv2c::lv2_plugin;

namespace record_plugin{
    class ToobLooperFourBase: public Lv2PluginWithState {
    public:
        static constexpr const char* URI = "http://two-play.com/plugins/toob-looper-four";
        ToobLooperFourBase(double rate,const char*bundlePath,const LV2_Feature *const *features)
        :   Lv2PluginWithState(rate,bundlePath,features)
        {
        }
    public:

        enum class PortId {
            control1 = 0,
            stop1 = 1,
            record1 = 2,
            record_led1 = 3,
            play1 = 4,
            play_led1 = 5,
            position1 = 6,
            control2 = 7,
            stop2 = 8,
            record2 = 9,
            record_led2 = 10,
            play2 = 11,
            play_led2 = 12,
            position2 = 13,
            control3 = 14,
            stop3 = 15,
            record3 = 16,
            record_led3 = 17,
            play3 = 18,
            play_led3 = 19,
            position3 = 20,
            control4 = 21,
            stop4 = 22,
            record4 = 23,
            record_led4 = 24,
            play4 = 25,
            play_led4 = 26,
            position4 = 27,
            bar_led = 28,
            beat_led = 29,
            tempo = 30,
            timesig = 31,
            rec_count_in = 32,
            trigger_level = 33,
            trigger_led = 34,
            bars = 35,
            rec_sync_option = 36,
            loop_end_option = 37,
            level = 38,
            in = 39,
            out = 40,
            controlIn = 41,
            controlOut = 42,
            inR = 43,
            outR = 44,
        };

    protected:
        ToggledInputPort control1{};
        TriggerInputPort stop1{};
        TriggerInputPort record1{};
        RateLimitedOutputPort record_led1{0};
        TriggerInputPort play1{};
        RateLimitedOutputPort play_led1{0};
        RateLimitedOutputPort position1{0};
        ToggledInputPort control2{};
        TriggerInputPort stop2{};
        TriggerInputPort record2{};
        RateLimitedOutputPort record_led2{0};
        TriggerInputPort play2{};
        RateLimitedOutputPort play_led2{0};
        RateLimitedOutputPort position2{0};
        ToggledInputPort control3{};
        TriggerInputPort stop3{};
        TriggerInputPort record3{};
        RateLimitedOutputPort record_led3{0};
        TriggerInputPort play3{};
        RateLimitedOutputPort play_led3{0};
        RateLimitedOutputPort position3{0};
        ToggledInputPort control4{};
        TriggerInputPort stop4{};
        TriggerInputPort record4{};
        RateLimitedOutputPort record_led4{0};
        TriggerInputPort play4{};
        RateLimitedOutputPort play_led4{0};
        RateLimitedOutputPort position4{0};
        RateLimitedOutputPort bar_led{0};
        RateLimitedOutputPort beat_led{0};
        RangedInputPort tempo{40,240};
        RangedInputPort timesig{0,5};
        RangedInputPort rec_count_in{0,2};
        RangedDbInputPort trigger_level{-60,0};
        RateLimitedOutputPort trigger_led{0};
        RangedInputPort bars{0,32};
        ToggledInputPort rec_sync_option{};
        RangedInputPort loop_end_option{1,2};
        RangedDbInputPort level{-60,30};
        AudioInputPort in{};
        AudioOutputPort out{};
        AtomInputPort controlIn{};
        AtomOutputPort controlOut{};
        AudioInputPort inR{};
        AudioOutputPort outR{};

        virtual void ConnectPort(uint32_t port, void *data) override
        {
            switch ((PortId)port)
            {
            case PortId::control1:
                control1.SetData(data);
                break;
            case PortId::stop1:
                stop1.SetData(data);
                break;
            case PortId::record1:
                record1.SetData(data);
                break;
            case PortId::record_led1:
                record_led1.SetData(data);
                break;
            case PortId::play1:
                play1.SetData(data);
                break;
            case PortId::play_led1:
                play_led1.SetData(data);
                break;
            case PortId::position1:
                position1.SetData(data);
                break;
            case PortId::control2:
                control2.SetData(data);
                break;
            case PortId::stop2:
                stop2.SetData(data);
                break;
            case PortId::record2:
                record2.SetData(data);
                break;
            case PortId::record_led2:
                record_led2.SetData(data);
                break;
            case PortId::play2:
                play2.SetData(data);
                break;
            case PortId::play_led2:
                play_led2.SetData(data);
                break;
            case PortId::position2:
                position2.SetData(data);
                break;
            case PortId::control3:
                control3.SetData(data);
                break;
            case PortId::stop3:
                stop3.SetData(data);
                break;
            case PortId::record3:
                record3.SetData(data);
                break;
            case PortId::record_led3:
                record_led3.SetData(data);
                break;
            case PortId::play3:
                play3.SetData(data);
                break;
            case PortId::play_led3:
                play_led3.SetData(data);
                break;
            case PortId::position3:
                position3.SetData(data);
                break;
            case PortId::control4:
                control4.SetData(data);
                break;
            case PortId::stop4:
                stop4.SetData(data);
                break;
            case PortId::record4:
                record4.SetData(data);
                break;
            case PortId::record_led4:
                record_led4.SetData(data);
                break;
            case PortId::play4:
                play4.SetData(data);
                break;
            case PortId::play_led4:
                play_led4.SetData(data);
                break;
            case PortId::position4:
                position4.SetData(data);
                break;
            case PortId::bar_led:
                bar_led.SetData(data);
                break;
            case PortId::beat_led:
                beat_led.SetData(data);
                break;
            case PortId::tempo:
                tempo.SetData(data);
                break;
            case PortId::timesig:
                timesig.SetData(data);
                break;
            case PortId::rec_count_in:
                rec_count_in.SetData(data);
                break;
            case PortId::trigger_level:
                trigger_level.SetData(data);
                break;
            case PortId::trigger_led:
                trigger_led.SetData(data);
                break;
            case PortId::bars:
                bars.SetData(data);
                break;
            case PortId::rec_sync_option:
                rec_sync_option.SetData(data);
                break;
            case PortId::loop_end_option:
                loop_end_option.SetData(data);
                break;
            case PortId::level:
                level.SetData(data);
                break;
            case PortId::in:
                in.SetData(data);
                break;
            case PortId::out:
                out.SetData(data);
                break;
            case PortId::controlIn:
                controlIn.SetData(data);
                break;
            case PortId::controlOut:
                controlOut.SetData(data);
                break;
            case PortId::inR:
                inR.SetData(data);
                break;
            case PortId::outR:
                outR.SetData(data);
                break;
            default:
                LogError("Invalid port id");
                break;
            }
        }
        virtual void Activate() override
        {
            SetAtomPortBuffers((LV2_Atom_Sequence*)(controlIn.Get()), (LV2_Atom_Sequence*)(controlOut.Get()));
            record_led1.SetSampleRate((float)getRate());
            play_led1.SetSampleRate((float)getRate());
            position1.SetSampleRate((float)getRate());
            record_led2.SetSampleRate((float)getRate());
            play_led2.SetSampleRate((float)getRate());
            position2.SetSampleRate((float)getRate());
            record_led3.SetSampleRate((float)getRate());
            play_led3.SetSampleRate((float)getRate());
            position3.SetSampleRate((float)getRate());
            record_led4.SetSampleRate((float)getRate());
            play_led4.SetSampleRate((float)getRate());
            position4.SetSampleRate((float)getRate());
            bar_led.SetSampleRate((float)getRate());
            beat_led.SetSampleRate((float)getRate());
            trigger_led.SetSampleRate((float)getRate());
        }
    };
} // namespace
#endif
