// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

namespace record_plugin{
    class ToobLooperOneUiBase: public lv2c::ui::Lv2PluginInfo{
    public:
        static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-looper-one-ui";
        using super=lv2c::ui::Lv2PluginInfo;
        using ptr=std::shared_ptr<ToobLooperOneUiBase>;
        static ptr Create() { return std::make_shared<ToobLooperOneUiBase>(); }

        ToobLooperOneUiBase() {
            using namespace lv2c::ui;

            uri("http://two-play.com/plugins/toob-looper-one");
            name("TooB One-Button Looper (stereo)");
            brand("TooB");
            label("One-Looper");
            plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
            supported_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            required_features({});
            optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            author_name("Robin Davies");
            author_homepage("https://github.com/sponsors/rerdavies");
            comment("## TooB One-Button Looper. \n\nTooB One-Button Looper is designed to be controlled by a single MIDI foot controller. If you will be controlling your looper from a screen user-interface, use Toob 4Looper instead. \n\n### Basic Operation\n\nTo use the One-Button Looper with PiPedal, bind a MIDI foot switch to the control port using the PiPedal MIDI Bindings user-interface. It's easiest to configure\nthe MIDI foot controller to send Note-On/Note-Off midi messages, since the control values that a MIDI foot controller sends may not be consistent with what the\nOne-Button Looper expects. However, if you must use a MIDI foot controller that sends Control Change messages, then you must configure the MIDI foot controller \nto send a CC value of zero when not pressed, and a non-zero value when pressed.\n\n\nLoop overdubs are stored in a stack, so that they can be erased one at a time. To erase the most recent overdub, and return to the previous state of the loop,\nlong-press the MIDI controller (or the Control button if you are using the PiPedal user interface). A long-press is a press of at least 1/2 second, but \nless than two seconds. The current loop will be undone when you release the control. To stop looping altogether, press the MIDI foot controller (or the Control button) for at least two seconds. The looper will stop when you \nrelease the control.\n\n### Clock Options\n\nClock options determine the tempo and number of beats in a bar. They affect the behavior of the looper when the Bars control (see below) is set to \na numeric value, and also affect the rate of the flashing LEDs when counting in. \n\n### Record Options\n\nRecord Options control the behavior of the looper.  \n\nThe Rec Start control determines when recording start. If set to Immediate, the looper will start recording as soon as you tap the Control button. \nWhen set to Count In, the main loop will count in before it starts recording. The Record LED will flash when counting in, and go solid \nonce recording starts. The pattern of blinking lights depends on the TimeSig setting, so for example, if the Time Signature is set to 4/4, the \nblinking LED will signal a count-in pattern of \"1 - 2 - 1 2 3 4\". Secondary loops start overdubbing immediately, unless the Rec Sync button \nis enabled.  When set to Trigger, the looper will not start recording until it detects a signal on audio input. The Trig Lvl control sets how loud the \nsignal must be in order to start recording. \n\nWhen Bars is set to Free (the minimum value), the length of the main loop will be set by a second tap of the \nControl button after recording of the main loop starts. If Bars is set to a numeric value, the length of the main loop (and all secondarhy loops) will \nbe determined by the number of bars set in the Bars control, and the current settings of the Clock controls. \n\nIf Dub Sync is off, overdubs will start recording as soon as you tap the Control button. If enabled, the start \nof the secondary loop will sync with main loop. Tapping the Control button will put the looper in \"Cue Overdub\" state\nand the LEDs will flash until the end of the main loop is reached, at which point the new loop will start recording. \n\nThe Loop End option only has effect when the Bars control is set to a numeric value, and does nothing if Bars is set to \"Free\". \nWhen set to REC-PLAY, the main loop will record exactly N bars of audio, and switch to play mode when the end of the loop is reached. \nWhen set to REC-DUB, the main loop will record exactly N bars of audio, and then continue on in overdub mode. \n\n### Looper State Table\n\n```\n+-----------+--------------+----------------------------------+\n| State     | Action       | Effect                           |\n|-----------|--------------|----------------------------------|\n| Empty     | Tap          | Start counting in if COUNT IN is |\n|           |              | enabled; otherwise start         |\n|           |              | recording immediately.           |\n|-----------|--------------|----------------------------------|\n| Count-In  | Tap/         | Return to empty state            |\n|           | Long-press   |                                  |\n|           |              |                                  |\n|           | Complete     | Start recording                  |\n|-----------|--------------|----------------------------------|\n| Recording | Tap          | Set the loop length and go to    |\n|           |              | play state.                      |\n|           |              |                                  |\n|           | Long-press   | Discard the current loop and     |\n|           |              | return to Empty state            |\n|           |              |                                  |\n|           | End of loop  | go to play or overdub state      |\n|           |              | depending on ON REC END          |\n|-----------|--------------|----------------------------------|\n| Playing   | Tap          | If DUB SYNC is on, go to         |\n|           |              | Cue Ovdb state; otherwise        |\n|           |              | start overdubbing immediately.   |\n|           |              |                                  |\n|           | Long-press   | Undo the most recent             |\n|           |              | overdub and go to play           |\n|           |              | state.                           |\n|-----------|--------------|----------------------------------|\n| Cue Ovdb  | End-of-loop  | Start overdubbing.               |\n|           |              |                                  |\n|           | Tap          | Cancel the pending overdub.      |      \n|           |              |                                  |\n|           | Long-press   | Cancel the pending overdub.      |\n|-----------|--------------|----------------------------------|\n| Overdub   | Tap          | Start playing.                   |\n|           |              |                                  |\n|           | End of loop  | (If DUB SYNC is on, and          |\n|           |              | REC->PLAY is selected) Go to     |\n|           |              | play state, otherwise, continue  |\n|           |              | in overdub state.                |\n+-----------|--------------|----------------------------------+\n```");
            extensions({"http://lv2plug.in/ns/ext/state#interface"});
            ports({
                Lv2PortInfo_Init {
                    .index_ = 0,
                    .symbol_ = "control",
                    .name_ = "〇",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .integer_property_ = true,
                    .mod_momentaryOffByDefault_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#loop_main_group",
                    .comment_ = "Looper control. See the plugin documentation for details.",
                },
                Lv2PortInfo_Init {
                    .index_ = 1,
                    .symbol_ = "record_led",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#loop_main_group",
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 2,
                    .symbol_ = "play_led",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#loop_main_group",
                    .pipedal_ledColor_ = "green",
                },
                Lv2PortInfo_Init {
                    .index_ = 3,
                    .symbol_ = "position",
                    .name_ = "    ",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#loop_main_group",
                    .units_ = Lv2Units::pc,
                    .comment_ = "Loop position",
                },
                Lv2PortInfo_Init {
                    .index_ = 4,
                    .symbol_ = "loop_level",
                    .name_ = "    ",
                    .max_value_ = 21,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .scale_points_ = {Lv2ScalePoint{0,"-"},Lv2ScalePoint{1,"1"},Lv2ScalePoint{2,"2"},Lv2ScalePoint{3,"3"},Lv2ScalePoint{4,"4"},Lv2ScalePoint{5,"5"},Lv2ScalePoint{6,"6"},Lv2ScalePoint{7,"7"},Lv2ScalePoint{8,"8"},Lv2ScalePoint{9,"9"},Lv2ScalePoint{10,"10"},Lv2ScalePoint{11,"11"},Lv2ScalePoint{12,"12"},Lv2ScalePoint{13,"13"},Lv2ScalePoint{14,"14"},Lv2ScalePoint{15,"15"},Lv2ScalePoint{16,"16"},Lv2ScalePoint{17,"17"},Lv2ScalePoint{18,"18"},Lv2ScalePoint{19,"19"},Lv2ScalePoint{20,"20"},Lv2ScalePoint{21,"+"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .enumeration_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#loop_main_group",
                    .comment_ = "Loop Level",
                },
                Lv2PortInfo_Init {
                    .index_ = 5,
                    .symbol_ = "bar_led",
                    .name_ = "  Bar  ",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#syncGroup",
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 6,
                    .symbol_ = "beat_led",
                    .name_ = " Beat ",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#syncGroup",
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 7,
                    .symbol_ = "tempo",
                    .name_ = "Tempo",
                    .min_value_ = 40,
                    .max_value_ = 240,
                    .default_value_ = 120,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#syncGroup",
                    .units_ = Lv2Units::bpm,
                    .comment_ = "Tempo in quarter-notes per minute",
                },
                Lv2PortInfo_Init {
                    .index_ = 8,
                    .symbol_ = "timesig",
                    .name_ = "TimeSig",
                    .max_value_ = 5,
                    .default_value_ = 2,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{0,"2/2"},Lv2ScalePoint{1,"3/4"},Lv2ScalePoint{2,"4/4"},Lv2ScalePoint{3,"5/4"},Lv2ScalePoint{4,"6/8"},Lv2ScalePoint{5,"7/4"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .enumeration_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#syncGroup",
                    .comment_ = "Time Signature",
                },
                Lv2PortInfo_Init {
                    .index_ = 9,
                    .symbol_ = "rec_count_in",
                    .name_ = "Rec Start",
                    .max_value_ = 2,
                    .default_value_ = 1,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{0,"Immediate"},Lv2ScalePoint{1,"Count in"},Lv2ScalePoint{2,"Trigger"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .enumeration_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#options_group",
                    .comment_ = "When to start recording.",
                },
                Lv2PortInfo_Init {
                    .index_ = 10,
                    .symbol_ = "trigger_level",
                    .name_ = "Trig Lvl",
                    .min_value_ = -60,
                    .max_value_ = 0,
                    .default_value_ = -25,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#options_group",
                    .units_ = Lv2Units::db,
                },
                Lv2PortInfo_Init {
                    .index_ = 11,
                    .symbol_ = "trigger_led",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#options_group",
                },
                Lv2PortInfo_Init {
                    .index_ = 12,
                    .symbol_ = "bars",
                    .name_ = "Bars",
                    .max_value_ = 32,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{0,"Free"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .integer_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#options_group",
                    .units_ = Lv2Units::bar,
                    .comment_ = "Loop length in bars. Set to minimum for arbitrary length loops.",
                },
                Lv2PortInfo_Init {
                    .index_ = 13,
                    .symbol_ = "rec_sync_option",
                    .name_ = "Dub Sync",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#options_group",
                    .comment_ = "Whether to sync the start of the loop with the main loop when recording secondary loops.",
                },
                Lv2PortInfo_Init {
                    .index_ = 14,
                    .symbol_ = "loop_end_option",
                    .name_ = "On Rec End",
                    .min_value_ = 1,
                    .max_value_ = 2,
                    .default_value_ = 1,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{1,"REC->PLAY"},Lv2ScalePoint{2,"REC->DUB"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .enumeration_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#options_group",
                    .comment_ = "Whether to go to OVERDUB or PLAY state a loop ends.",
                },
                Lv2PortInfo_Init {
                    .index_ = 15,
                    .symbol_ = "level",
                    .name_ = "Level",
                    .min_value_ = -60,
                    .max_value_ = 30,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{-60,"-INF"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#output_group",
                    .units_ = Lv2Units::db,
                },
                Lv2PortInfo_Init {
                    .index_ = 16,
                    .symbol_ = "in",
                    .name_ = "In",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#stereoInGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#left",
                },
                Lv2PortInfo_Init {
                    .index_ = 17,
                    .symbol_ = "out",
                    .name_ = "Out",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#stereoOutGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#left",
                },
                Lv2PortInfo_Init {
                    .index_ = 18,
                    .symbol_ = "controlIn",
                    .name_ = "ControlIn",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_atom_port_ = true,
                    .buffer_type_ = Lv2BufferType::Sequence,
                },
                Lv2PortInfo_Init {
                    .index_ = 19,
                    .symbol_ = "controlOut",
                    .name_ = "ControlOut",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_atom_port_ = true,
                    .buffer_type_ = Lv2BufferType::Sequence,
                },
                Lv2PortInfo_Init {
                    .index_ = 20,
                    .symbol_ = "inR",
                    .name_ = "InR",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#stereoInGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#right",
                },
                Lv2PortInfo_Init {
                    .index_ = 21,
                    .symbol_ = "outR",
                    .name_ = "OutR",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-looper-one#stereoOutGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#right",
                },
            });
            port_groups({Lv2PortGroup{"http://two-play.com/plugins/toob-looper-one#loop_main_group","loop_main_group","Control"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-one#syncGroup","sync_g","Clock"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-one#options_group","options_group","Record Options"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-one#output_group","output_group","Output"},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-one#stereoInGroup","in_g",""},Lv2PortGroup{"http://two-play.com/plugins/toob-looper-one#stereoOutGroup","",""}});
            has_factory_presets(false);
            piPedalUI(PiPedalUI{
                {
                },
                {
                },
                {
                }
            });
        }
    };
} // namespace
#endif
#ifdef DEFINE_LV2_PLUGIN_BASE
#include <lv2_plugin/Lv2Plugin.hpp>
#include <lv2_plugin/Lv2Ports.hpp>
using namespace lv2c::lv2_plugin;

namespace record_plugin{
    class ToobLooperOneBase: public Lv2PluginWithState {
    public:
        static constexpr const char* URI = "http://two-play.com/plugins/toob-looper-one";
        ToobLooperOneBase(double rate,const char*bundlePath,const LV2_Feature *const *features)
        :   Lv2PluginWithState(rate,bundlePath,features)
        {
        }
    public:

        enum class PortId {
            control = 0,
            record_led = 1,
            play_led = 2,
            position = 3,
            loop_level = 4,
            bar_led = 5,
            beat_led = 6,
            tempo = 7,
            timesig = 8,
            rec_count_in = 9,
            trigger_level = 10,
            trigger_led = 11,
            bars = 12,
            rec_sync_option = 13,
            loop_end_option = 14,
            level = 15,
            in = 16,
            out = 17,
            controlIn = 18,
            controlOut = 19,
            inR = 20,
            outR = 21,
        };

    protected:
        ToggledInputPort control{};
        RateLimitedOutputPort record_led{0};
        RateLimitedOutputPort play_led{0};
        RateLimitedOutputPort position{0};
        RateLimitedOutputPort loop_level{0};
        RateLimitedOutputPort bar_led{0};
        RateLimitedOutputPort beat_led{0};
        RangedInputPort tempo{40,240};
        RangedInputPort timesig{0,5};
        RangedInputPort rec_count_in{0,2};
        RangedDbInputPort trigger_level{-60,0};
        RateLimitedOutputPort trigger_led{0};
        RangedInputPort bars{0,32};
        ToggledInputPort rec_sync_option{};
        RangedInputPort loop_end_option{1,2};
        RangedDbInputPort level{-60,30};
        AudioInputPort in{};
        AudioOutputPort out{};
        AtomInputPort controlIn{};
        AtomOutputPort controlOut{};
        AudioInputPort inR{};
        AudioOutputPort outR{};

        virtual void ConnectPort(uint32_t port, void *data) override
        {
            switch ((PortId)port)
            {
            case PortId::control:
                control.SetData(data);
                break;
            case PortId::record_led:
                record_led.SetData(data);
                break;
            case PortId::play_led:
                play_led.SetData(data);
                break;
            case PortId::position:
                position.SetData(data);
                break;
            case PortId::loop_level:
                loop_level.SetData(data);
                break;
            case PortId::bar_led:
                bar_led.SetData(data);
                break;
            case PortId::beat_led:
                beat_led.SetData(data);
                break;
            case PortId::tempo:
                tempo.SetData(data);
                break;
            case PortId::timesig:
                timesig.SetData(data);
                break;
            case PortId::rec_count_in:
                rec_count_in.SetData(data);
                break;
            case PortId::trigger_level:
                trigger_level.SetData(data);
                break;
            case PortId::trigger_led:
                trigger_led.SetData(data);
                break;
            case PortId::bars:
                bars.SetData(data);
                break;
            case PortId::rec_sync_option:
                rec_sync_option.SetData(data);
                break;
            case PortId::loop_end_option:
                loop_end_option.SetData(data);
                break;
            case PortId::level:
                level.SetData(data);
                break;
            case PortId::in:
                in.SetData(data);
                break;
            case PortId::out:
                out.SetData(data);
                break;
            case PortId::controlIn:
                controlIn.SetData(data);
                break;
            case PortId::controlOut:
                controlOut.SetData(data);
                break;
            case PortId::inR:
                inR.SetData(data);
                break;
            case PortId::outR:
                outR.SetData(data);
                break;
            default:
                LogError("Invalid port id");
                break;
            }
        }
        virtual void Activate() override
        {
            SetAtomPortBuffers((LV2_Atom_Sequence*)(controlIn.Get()), (LV2_Atom_Sequence*)(controlOut.Get()));
            record_led.SetSampleRate((float)getRate());
            play_led.SetSampleRate((float)getRate());
            position.SetSampleRate((float)getRate());
            loop_level.SetSampleRate((float)getRate());
            bar_led.SetSampleRate((float)getRate());
            beat_led.SetSampleRate((float)getRate());
            trigger_led.SetSampleRate((float)getRate());
        }
    };
} // namespace
#endif
