// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

class ToobMLInfo: public lv2c::ui::Lv2PluginInfo{
public:
    static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-ml-ui";
    using super=lv2c::ui::Lv2PluginInfo;
    using ptr=std::shared_ptr<ToobMLInfo>;
    static ptr Create() { return std::make_shared<ToobMLInfo>(); }

    ToobMLInfo() {
        using namespace lv2c::ui;

        uri("http://two-play.com/plugins/toob-ml");
        name("TooB ML Amplifier");
        brand("TooB");
        label("TooB ML");
        plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
        supported_features({"http://lv2plug.in/ns/ext/state#mapPath","http://lv2plug.in/ns/ext/state#makePath","http://lv2plug.in/ns/ext/worker#schedule","http://lv2plug.in/ns/ext/urid#map","http://lv2plug.in/ns/ext/state#:freePath"});
        required_features({"http://lv2plug.in/ns/ext/worker#schedule","http://lv2plug.in/ns/ext/urid#map"});
        optional_features({"http://lv2plug.in/ns/ext/state#:freePath","http://lv2plug.in/ns/ext/state#makePath","http://lv2plug.in/ns/ext/state#mapPath"});
        author_name("Robin Davies");
        author_homepage("https://github.com/sponsors/rerdavies");
        comment("The TooB ML Amplifier plugin provides emulation of a variety of amplifiers and overdrive pedals that are implemented \nusing neural-network-based machine learning models of real amplifiers.\n\nGenerally, TooB ML uses smaller and more efficient neural networks than does TooB Neural Amp Modeller. As a result,\nTooB ML models use significantly less CPU, although TooB Neural Amp Modeller is significantly more flexible, and\nhas a huge number of downloadable models.\n\nTooB ML models are compatible with models from the GuitarML project (). You can download new models from the GuitarML project \nat \n\n    https://guitarml.com/tonelibrary/tonelib-pro.html\n\nTo use GuitarML models, download them locally using your browser, and then upload them to TooB ML using the following steps:\n\n- Load Toob ML in PiPedal.\n\n- Click on the \"Models\" control.\n\n- Click on the _Upload_ button in the lower left corner of the selection dialog.\n\n- Select the file that you downloaded localy.\n\nTooB ML can upload indiviual .json files, or collections of models in .zip files downloaded from the GuitarML site.\n\nSome models have an additional Gain control that can be used to simulate the effect of a Gain control on the amplifier \nbeing simulated. The gain control will be enabled if the model you have selected has a gain input.\n\nFor convenience, tone controls are provided for rough shaping of tone before the input signal is fed to the neural net models. The tone \nsection can be completely bypassed by setting all tone controls to exactly 0.5.\n\nThe Sag section models transformer sag using DSP simulation, since transformer sag is not captured well by neural network models. A modest amount \nof transformer sag produces an amp simulation that feels  more \"forgiving\". The Sag section is not based on neural network modelling.\n\nTo disable transformer modelling, set the Sag Out and Sag Feedback controls to zero. \n\nThe SagF control affects the cutoff frequency of a low-pass filter which is used to calculate the amount of transformer sag. Lower values produce a faster \nonset; higher values produce a slower onset. Nominally, SagF should be set to 13Hz, which loosely models the transformer sag of a Fender Bassman based \non circuit simulations.\n\nThe Sag Feedback control uses the calculated transformer voltage sag to scale the signal level of the input to the model. For models with gentle overdrive, it tends to keep the model operating in the sweet stop where the model is \non the edge of breakup. It does not work particularly well for models of heavily overdriven amplifiers. The effect of Sag Out is similar to that of an analog \ncompressor. Notionally, Sag Feedback models the effect of transformer sag on intermediate transformer stages (which causes them to clip at a lower level than\nthey ordinarily would); and Sag Out models the effect of transformer sag on the final power stage of a guitar amplifier.\n\nThe TooB ML Amplifier is based heavily on code ported from from the RTNeural project (https://github.com/jatinchowdhury18/RTNeural), by Jatin Chowdhury,\nand uses model files from the GuitarML Neural Pi project (https://github.com/GuitarML/NeuralPi).");
        extensions({"http://lv2plug.in/ns/ext/worker#interface","http://lv2plug.in/ns/ext/state#interface"});
        ports({
            Lv2PortInfo_Init {
                .index_ = 0,
                .symbol_ = "trim",
                .name_ = "Trim",
                .min_value_ = -30,
                .max_value_ = 30,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Input volume trim (pre-model)",
            },
            Lv2PortInfo_Init {
                .index_ = 1,
                .symbol_ = "trimOut",
                .min_value_ = -35,
                .max_value_ = 10,
                .default_value_ = -35,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
            },
            Lv2PortInfo_Init {
                .index_ = 2,
                .symbol_ = "model",
                .name_ = "Model",
                .min_value_ = -1,
                .max_value_ = 32,
                .default_value_ = -1,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{0,"BluesJR"},Lv2ScalePoint{1,"BluesJR FullD"},Lv2ScalePoint{2,"BossDistortionDs1 highGain"},Lv2ScalePoint{3,"BossMetalZoneMt2 highGain"},Lv2ScalePoint{4,"DumbleClone clean"},Lv2ScalePoint{5,"DumbleClone highGain"},Lv2ScalePoint{6,"DumbleClone medGain"},Lv2ScalePoint{7,"EH CockFight highDrive"},Lv2ScalePoint{8,"FenderPrinceton clean"},Lv2ScalePoint{9,"FenderPrinceton highLevel"},Lv2ScalePoint{10,"Goat DistortionGen highDist"},Lv2ScalePoint{11,"Goat DistortionGen lowDist"},Lv2ScalePoint{12,"HT40 Overdrive"},Lv2ScalePoint{13,"LittleBigMuff"},Lv2ScalePoint{14,"MIAudio Crunchbox highGain"},Lv2ScalePoint{15,"MIAudio Crunchbox midGain"},Lv2ScalePoint{16,"MesaBoogieMk2b Clean"},Lv2ScalePoint{17,"MesaBoogieMk2b Crunch"},Lv2ScalePoint{18,"MesaBoogieMk2b highGain"},Lv2ScalePoint{19,"MesaBoogie Studio22 Clean"},Lv2ScalePoint{20,"MesaBoogie Studio22 highGain"},Lv2ScalePoint{21,"PAiA AxeGrinder highDist"},Lv2ScalePoint{22,"ProCoRat"},Lv2ScalePoint{23,"RockmanXPR Clean"},Lv2ScalePoint{24,"RockmanXPR Distortion"},Lv2ScalePoint{25,"Rockman Acoustic"},Lv2ScalePoint{26,"Rockman Ultimatum highGain"},Lv2ScalePoint{27,"Soldano crunch"},Lv2ScalePoint{28,"Soldano highGain"},Lv2ScalePoint{29,"TS9"},Lv2ScalePoint{30,"TS9 FullD"},Lv2ScalePoint{31,"WamplerTumnus highGain"},Lv2ScalePoint{32,"XoticCompSP"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .enumeration_property_ = true,
                .not_on_gui_ = true,
                .comment_ = "Select neural network model.",
            },
            Lv2PortInfo_Init {
                .index_ = 3,
                .symbol_ = "gain",
                .name_ = "Gain",
                .max_value_ = 10,
                .default_value_ = 3,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .comment_ = "Model gain parameter (if supported by model) ()",
            },
            Lv2PortInfo_Init {
                .index_ = 4,
                .symbol_ = "master",
                .name_ = "Master",
                .min_value_ = -30,
                .max_value_ = 30,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Output volume trim (post-model)",
            },
            Lv2PortInfo_Init {
                .index_ = 5,
                .symbol_ = "bass",
                .name_ = "Bass",
                .default_value_ = 0.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-ml#filterGroup",
                .comment_ = "Bass eq (pre-model)",
            },
            Lv2PortInfo_Init {
                .index_ = 6,
                .symbol_ = "mid",
                .name_ = "Mid",
                .default_value_ = 0.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-ml#filterGroup",
                .comment_ = "Mid eq (pre-model)",
            },
            Lv2PortInfo_Init {
                .index_ = 7,
                .symbol_ = "treble",
                .name_ = "Treble",
                .default_value_ = 0.5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-ml#filterGroup",
                .comment_ = "Treble eq (pre-model)",
            },
            Lv2PortInfo_Init {
                .index_ = 8,
                .symbol_ = "sag",
                .name_ = "Sag Out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-ml#sagGroup",
                .comment_ = "How much transformer sag affects output volume, post-model. Similar to an analog compressor effect.",
            },
            Lv2PortInfo_Init {
                .index_ = 9,
                .symbol_ = "sagd",
                .name_ = "Sag Feedback",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-ml#sagGroup",
                .comment_ = "Transformer sag feedback. How much transformer sag affects the input signal to the model. Tends to keep the model on the edge of breakup.",
            },
            Lv2PortInfo_Init {
                .index_ = 10,
                .symbol_ = "sagf",
                .name_ = "SagF",
                .min_value_ = 5,
                .max_value_ = 25,
                .default_value_ = 13,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-ml#sagGroup",
                .units_ = Lv2Units::hz,
                .comment_ = "Sag filter frequency.",
            },
            Lv2PortInfo_Init {
                .index_ = 11,
                .symbol_ = "gainEnable",
                .name_ = "GainEnable",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .not_on_gui_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 12,
                .symbol_ = "in",
                .name_ = "In",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 13,
                .symbol_ = "out",
                .name_ = "Out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 14,
                .symbol_ = "control",
                .name_ = "Control",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
            Lv2PortInfo_Init {
                .index_ = 15,
                .symbol_ = "notify",
                .name_ = "Notify",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
        });
        port_groups({Lv2PortGroup{"http://two-play.com/plugins/toob-ml#filterGroup","filter","EQ"},Lv2PortGroup{"http://two-play.com/plugins/toob-ml#sagGroup","sag","Transformer Sag"}});
        has_factory_presets(true);
        piPedalUI(PiPedalUI{
            {
                UiFileProperty_Init{
                    .label_ = "Model",
                    .index_ = 2,
                    .directory_ = "ToobMlModels",
                    .resourceDirectory_ = "models/tones",
                    .fileTypes_ = {UiFileType{".ml file","application/zip",".zip"},UiFileType{".json file","application/json",".json"}},
                    .patchProperty_ = "http://two-play.com/plugins/toob-ml#modelFile",
                },
            },
            {
                UiFrequencyPlot_Init {
                    .patchProperty_ = "http://two-play.com/plugins/toob#frequencyResponseVector",
                    .index_ = 8,
                    .portGroup_ = "http://two-play.com/plugins/toob-ml#filterGroup",
                    .xLeft_ = 30,
                    .xRight_ = 22050,
                    .yTop_ = 10,
                    .yBottom_ = -35,
                    .width_ = 160,
                },
            },
            {
            }
        });
    }
};
#endif
