// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

class NeuralAmpModelerInfo: public lv2c::ui::Lv2PluginInfo{
public:
    static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-nam-ui";
    using super=lv2c::ui::Lv2PluginInfo;
    using ptr=std::shared_ptr<NeuralAmpModelerInfo>;
    static ptr Create() { return std::make_shared<NeuralAmpModelerInfo>(); }

    NeuralAmpModelerInfo() {
        using namespace lv2c::ui;

        uri("http://two-play.com/plugins/toob-nam");
        name("TooB Neural Amp Modeler");
        brand("TooB");
        label("TooB NAM");
        plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
        supported_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
        required_features({});
        optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
        author_name("Robin Davies");
        author_homepage("https://github.com/sponsors/rerdavies");
        comment("A port of Steven Atkinson's Neural Amp Modeler to LV2. \n\nTooB Neural Amp Modeler uses uploadable .nam model files. Download .nam files from http://tonehunt.org, and then load them into TooB Neural Amp Modeler. \n\nIf you are using TooB Neural Amp Modeler from PiPedal, download the model files to the system on which you are running the client. You must then\nupload the file to the PiPedal server. Click on the \"Model\" control and then search for the Upload button in the file browser. Once uploaded to the server,\nyou can then select the uploaded file in the browser directly.\n\nIf you are not using PiPedal, just click on the Model control, and use the file browser to select the .nam file on your local system.\n\nTooB Neural Amp Modeler supports a much wider range of amp models than ToobML, but usually uses much more CPU. \nYou will need at least a Pi 4 to use Toob Neural Amp Modeler, and you may need to increase your audio buffer sizes to prevent overruns. \nIf you are having trouble with CPU usage, tonehunt.org does contain some smaller amp models. Search for the \"feather\" tag to find\nmodels that use less CPU.\n\nIf you are interested in building your own amp models, please visit https://www.neuralampmodeler.com/\n\nTooB Neural Amp Modeler uses code from the NeuralAmp Modeler Core project. The TooB Team wishes to express gratitude to Steven Atkinson for\nmaking this extraordinary technology available as open-source code.\n\nCode from the the NeuralAmpModelerCore project (https://github.com/sdatkinson/NeuralAmpModelerCore) is provided under the following license.\n\nMIT License\n\nCopyright (c) 2023 Steven Atkinson\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.");
        extensions({"http://lv2plug.in/ns/ext/state#interface","http://lv2plug.in/ns/ext/worker#interface"});
        ports({
            Lv2PortInfo_Init {
                .index_ = 0,
                .symbol_ = "inputGain",
                .name_ = "Input Gain",
                .min_value_ = -40,
                .max_value_ = 40,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Input gain",
            },
            Lv2PortInfo_Init {
                .index_ = 1,
                .symbol_ = "inputGainOut",
                .min_value_ = -35,
                .max_value_ = 20,
                .default_value_ = -35,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
            },
            Lv2PortInfo_Init {
                .index_ = 2,
                .symbol_ = "outputGain",
                .name_ = "Output Gain",
                .min_value_ = -40,
                .max_value_ = 40,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Output gain",
            },
            Lv2PortInfo_Init {
                .index_ = 3,
                .symbol_ = "gate",
                .name_ = "Noise Gate",
                .min_value_ = -100,
                .max_value_ = 0,
                .default_value_ = -100,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{-100,"Off"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "Noise gate threshold. Set to minimum to disable.",
            },
            Lv2PortInfo_Init {
                .index_ = 4,
                .symbol_ = "gateOut",
                .name_ = " ",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .toggled_property_ = true,
                .comment_ = "Gate Status",
            },
            Lv2PortInfo_Init {
                .index_ = 5,
                .symbol_ = "toneStack",
                .name_ = "Type",
                .max_value_ = 3,
                .default_value_ = 3,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .scale_points_ = {Lv2ScalePoint{0,"Bassman"},Lv2ScalePoint{1,"JCM8000"},Lv2ScalePoint{2,"Baxandall"},Lv2ScalePoint{3,"Bypass"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .enumeration_property_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-nam#eqGroup",
                .comment_ = "Tonestack type",
            },
            Lv2PortInfo_Init {
                .index_ = 6,
                .symbol_ = "bass",
                .name_ = "Bass",
                .max_value_ = 10,
                .default_value_ = 5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-nam#eqGroup",
                .comment_ = "Bass",
            },
            Lv2PortInfo_Init {
                .index_ = 7,
                .symbol_ = "mid",
                .name_ = "Mid",
                .max_value_ = 10,
                .default_value_ = 5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-nam#eqGroup",
                .comment_ = "Mid",
            },
            Lv2PortInfo_Init {
                .index_ = 8,
                .symbol_ = "treble",
                .name_ = "Treble",
                .max_value_ = 10,
                .default_value_ = 5,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .port_group_ = "http://two-play.com/plugins/toob-nam#eqGroup",
                .comment_ = "Bass",
            },
            Lv2PortInfo_Init {
                .index_ = 9,
                .symbol_ = "in",
                .name_ = "In",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 10,
                .symbol_ = "out",
                .name_ = "Out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 11,
                .symbol_ = "control",
                .name_ = "Control",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Control",
            },
            Lv2PortInfo_Init {
                .index_ = 12,
                .symbol_ = "notify",
                .name_ = "Notify",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Notification",
            },
        });
        port_groups({Lv2PortGroup{"http://two-play.com/plugins/toob-nam#eqGroup","eqGroup","Tone"}});
        has_factory_presets(false);
        piPedalUI(PiPedalUI{
            {
                UiFileProperty_Init{
                    .label_ = "Model",
                    .index_ = 2,
                    .directory_ = "NeuralAmpModels",
                    .fileTypes_ = {UiFileType{".nam file","application/octet-stream",".nam"}},
                    .patchProperty_ = "http://two-play.com/plugins/toob-nam#modelFile",
                },
            },
            {
                UiFrequencyPlot_Init {
                    .patchProperty_ = "http://two-play.com/plugins/toob-nam#FrequencyResponse",
                    .index_ = 9,
                    .portGroup_ = "http://two-play.com/plugins/toob-nam#eqGroup",
                    .xLeft_ = 30,
                    .yBottom_ = -35,
                },
            },
            {
            }
        });
    }
};
#endif
