// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

namespace noise_gate_plugin{
    class ToobNoiseGateUiBase: public lv2c::ui::Lv2PluginInfo{
    public:
        static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-noise-gate-ui";
        using super=lv2c::ui::Lv2PluginInfo;
        using ptr=std::shared_ptr<ToobNoiseGateUiBase>;
        static ptr Create() { return std::make_shared<ToobNoiseGateUiBase>(); }

        ToobNoiseGateUiBase() {
            using namespace lv2c::ui;

            uri("http://two-play.com/plugins/toob-noise-gate");
            name("TooB Noise Gate");
            brand("TooB");
            label("TooB Noise Gate");
            plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
            supported_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            required_features({});
            optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            author_name("Robin Davies");
            author_homepage("https://github.com/sponsors/rerdavies");
            comment("A noise gate is an audio processing tool that controls the volume of an audio signal \nby allowing it to pass through only when it exceeds a set threshold. \nSignals below this threshold are muted or significantly reduced, \neffectively \"gating\" unwanted noise, such as background hum, hiss, or crosstalk, \nwhile preserving the desired sound, like vocals or instruments.\n\nThe Hysteresis control sets a secondary threshold, slightly below \nthe primary threshold, to determine when the gate closes. This creates a \"buffer zone\" \nto prevent the gate from rapidly toggling on and off (chattering) when the audio signal\n hovers near the primary threshold.\n\nFor example, if the Threshold contol is set to -30dB and Hysteresis control is set to -5dB, \nthe gate opens when the signal exceeds -30dB but only closes when it drops below -35 dB. \nThis smoother transition ensures cleaner gating, especially for signals with fluctuating levels, \nlike guitar.");
            extensions({});
            ports({
                Lv2PortInfo_Init {
                    .index_ = 0,
                    .symbol_ = "threshold",
                    .name_ = "Threshold",
                    .min_value_ = -60,
                    .max_value_ = 0,
                    .default_value_ = -30,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-noise-gate#trigger_group",
                    .units_ = Lv2Units::db,
                    .comment_ = "The level above which the gate opens.",
                },
                Lv2PortInfo_Init {
                    .index_ = 1,
                    .symbol_ = "hysteresis",
                    .name_ = "Hysteresis",
                    .min_value_ = -30,
                    .max_value_ = 0,
                    .default_value_ = -6,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-noise-gate#trigger_group",
                    .units_ = Lv2Units::db,
                    .comment_ = "Controls the level at which the gate will be held open.",
                },
                Lv2PortInfo_Init {
                    .index_ = 2,
                    .symbol_ = "trigger_led",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-noise-gate#trigger_group",
                },
                Lv2PortInfo_Init {
                    .index_ = 3,
                    .symbol_ = "reduction",
                    .name_ = "Range",
                    .min_value_ = -60,
                    .max_value_ = -6,
                    .default_value_ = -60,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-noise-gate#envelope_group",
                    .units_ = Lv2Units::db,
                    .comment_ = "The amount of attenuation applied when the gate is closed.",
                },
                Lv2PortInfo_Init {
                    .index_ = 4,
                    .symbol_ = "attack",
                    .name_ = "Attack",
                    .min_value_ = 1,
                    .max_value_ = 500,
                    .default_value_ = 1,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-noise-gate#envelope_group",
                    .units_ = Lv2Units::ms,
                    .comment_ = "Envelope Attack",
                },
                Lv2PortInfo_Init {
                    .index_ = 5,
                    .symbol_ = "hold",
                    .name_ = "Hold",
                    .min_value_ = 10,
                    .max_value_ = 1000,
                    .default_value_ = 100,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-noise-gate#envelope_group",
                    .units_ = Lv2Units::ms,
                    .comment_ = "Envelope Hold",
                },
                Lv2PortInfo_Init {
                    .index_ = 6,
                    .symbol_ = "release",
                    .name_ = "Release",
                    .min_value_ = 10,
                    .max_value_ = 5000,
                    .default_value_ = 330,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-noise-gate#envelope_group",
                    .units_ = Lv2Units::ms,
                    .comment_ = "Envelope Release",
                },
                Lv2PortInfo_Init {
                    .index_ = 7,
                    .symbol_ = "gate_level",
                    .min_value_ = -60,
                    .max_value_ = 0,
                    .default_value_ = -60,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-noise-gate#envelope_group",
                    .comment_ = "Gate Level",
                },
                Lv2PortInfo_Init {
                    .index_ = 8,
                    .symbol_ = "in",
                    .name_ = "In",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_audio_port_ = true,
                },
                Lv2PortInfo_Init {
                    .index_ = 9,
                    .symbol_ = "out",
                    .name_ = "Out",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_audio_port_ = true,
                },
            });
            port_groups({Lv2PortGroup{"http://two-play.com/plugins/toob-noise-gate#trigger_group","trigger_group","Trigger"},Lv2PortGroup{"http://two-play.com/plugins/toob-noise-gate#envelope_group","envelope_group","Envelope"}});
            has_factory_presets(false);
            piPedalUI(PiPedalUI{
                {
                },
                {
                },
                {
                }
            });
        }
    };
} // namespace
#endif
#ifdef DEFINE_LV2_PLUGIN_BASE
#include <lv2_plugin/Lv2Plugin.hpp>
#include <lv2_plugin/Lv2Ports.hpp>
using namespace lv2c::lv2_plugin;

namespace noise_gate_plugin{
    class ToobNoiseGateBase: public Lv2Plugin {
    public:
        static constexpr const char* URI = "http://two-play.com/plugins/toob-noise-gate";
        ToobNoiseGateBase(double rate,const char*bundlePath,const LV2_Feature *const *features)
        :   Lv2Plugin(rate,bundlePath,features)
        {
        }
    public:

        enum class PortId {
            threshold = 0,
            hysteresis = 1,
            trigger_led = 2,
            reduction = 3,
            attack = 4,
            hold = 5,
            release = 6,
            gate_level = 7,
            in = 8,
            out = 9,
        };

    protected:
        RangedDbInputPort threshold{-60,0};
        RangedDbInputPort hysteresis{-30,0};
        RateLimitedOutputPort trigger_led{0};
        RangedDbInputPort reduction{-60,-6};
        RangedInputPort attack{1,500};
        RangedInputPort hold{10,1000};
        RangedInputPort release{10,5000};
        RateLimitedOutputPort gate_level{-60};
        AudioInputPort in{};
        AudioOutputPort out{};

        virtual void ConnectPort(uint32_t port, void *data) override
        {
            switch ((PortId)port)
            {
            case PortId::threshold:
                threshold.SetData(data);
                break;
            case PortId::hysteresis:
                hysteresis.SetData(data);
                break;
            case PortId::trigger_led:
                trigger_led.SetData(data);
                break;
            case PortId::reduction:
                reduction.SetData(data);
                break;
            case PortId::attack:
                attack.SetData(data);
                break;
            case PortId::hold:
                hold.SetData(data);
                break;
            case PortId::release:
                release.SetData(data);
                break;
            case PortId::gate_level:
                gate_level.SetData(data);
                break;
            case PortId::in:
                in.SetData(data);
                break;
            case PortId::out:
                out.SetData(data);
                break;
            default:
                LogError("Invalid port id");
                break;
            }
        }
        virtual void Activate() override
        {
            SetAtomPortBuffers((LV2_Atom_Sequence*)(nullptr), (LV2_Atom_Sequence*)(nullptr));
            trigger_led.SetSampleRate((float)getRate());
            gate_level.SetSampleRate((float)getRate());
        }
    };
} // namespace
#endif
