// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

namespace record_plugin{
    class StereoRecordPluginUiInfo: public lv2c::ui::Lv2PluginInfo{
    public:
        static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-record-stereo-ui";
        using super=lv2c::ui::Lv2PluginInfo;
        using ptr=std::shared_ptr<StereoRecordPluginUiInfo>;
        static ptr Create() { return std::make_shared<StereoRecordPluginUiInfo>(); }

        StereoRecordPluginUiInfo() {
            using namespace lv2c::ui;

            uri("http://two-play.com/plugins/toob-record-stereo");
            name("TooB Record Input (stereo)");
            brand("TooB");
            label("Record Input");
            plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
            supported_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            required_features({});
            optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            author_name("Robin Davies");
            author_homepage("https://github.com/sponsors/rerdavies");
            comment("Record the plugin's audio input signal to a stereophonic file. See also: TooB Record Input (mono), which records a monophonic file.");
            extensions({"http://lv2plug.in/ns/ext/state#interface"});
            ports({
                Lv2PortInfo_Init {
                    .index_ = 0,
                    .symbol_ = "stop",
                    .name_ = "⏹",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .comment_ = "Stop.",
                },
                Lv2PortInfo_Init {
                    .index_ = 1,
                    .symbol_ = "record",
                    .name_ = "⏺",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .comment_ = "Start recording. Click again to stop.",
                },
                Lv2PortInfo_Init {
                    .index_ = 2,
                    .symbol_ = "record_led",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .pipedal_ledColor_ = "red",
                },
                Lv2PortInfo_Init {
                    .index_ = 3,
                    .symbol_ = "play",
                    .name_ = "⏵",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .trigger_ = true,
                    .toggled_property_ = true,
                    .comment_ = "Preview the recorded file. Click again to stop.",
                },
                Lv2PortInfo_Init {
                    .index_ = 4,
                    .symbol_ = "play_led",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .toggled_property_ = true,
                    .pipedal_ledColor_ = "green",
                },
                Lv2PortInfo_Init {
                    .index_ = 5,
                    .symbol_ = "record_time",
                    .max_value_ = 1000000,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .units_ = Lv2Units::s,
                    .comment_ = "Time",
                },
                Lv2PortInfo_Init {
                    .index_ = 6,
                    .symbol_ = "fformat",
                    .name_ = "Format",
                    .max_value_ = 3,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{0,"WAV"},Lv2ScalePoint{1,"WAV (float32)"},Lv2ScalePoint{2,"FLAC"},Lv2ScalePoint{3,"MP3"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .integer_property_ = true,
                    .enumeration_property_ = true,
                    .comment_ = "Recording File Format",
                },
                Lv2PortInfo_Init {
                    .index_ = 7,
                    .symbol_ = "level",
                    .name_ = "Level",
                    .min_value_ = -60,
                    .max_value_ = 30,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{-60,"-INF"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .units_ = Lv2Units::db,
                },
                Lv2PortInfo_Init {
                    .index_ = 8,
                    .symbol_ = "level_vu",
                    .min_value_ = -60,
                    .max_value_ = 20,
                    .default_value_ = -60,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_control_port_ = true,
                    .units_ = Lv2Units::db,
                    .comment_ = "Recording level",
                },
                Lv2PortInfo_Init {
                    .index_ = 9,
                    .symbol_ = "in",
                    .name_ = "In",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-record-stereo#stereoInGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#left",
                },
                Lv2PortInfo_Init {
                    .index_ = 10,
                    .symbol_ = "out",
                    .name_ = "Out",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-record-stereo#stereoOutGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#left",
                },
                Lv2PortInfo_Init {
                    .index_ = 11,
                    .symbol_ = "controlIn",
                    .name_ = "ControlIn",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_atom_port_ = true,
                    .buffer_type_ = Lv2BufferType::Sequence,
                },
                Lv2PortInfo_Init {
                    .index_ = 12,
                    .symbol_ = "controlOut",
                    .name_ = "ControlOut",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_atom_port_ = true,
                    .buffer_type_ = Lv2BufferType::Sequence,
                },
                Lv2PortInfo_Init {
                    .index_ = 13,
                    .symbol_ = "inR",
                    .name_ = "InR",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-record-stereo#stereoInGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#right",
                },
                Lv2PortInfo_Init {
                    .index_ = 14,
                    .symbol_ = "outR",
                    .name_ = "OutR",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_audio_port_ = true,
                    .port_group_ = "http://two-play.com/plugins/toob-record-stereo#stereoOutGroup",
                    .designation_ = "http://lv2plug.in/ns/ext/port-groups#right",
                },
            });
            port_groups({Lv2PortGroup{"http://two-play.com/plugins/toob-record-stereo#stereoInGroup","in_g",""},Lv2PortGroup{"http://two-play.com/plugins/toob-record-stereo#stereoOutGroup","",""}});
            has_factory_presets(false);
            piPedalUI(PiPedalUI{
                {
                    UiFileProperty_Init{
                        .label_ = "File",
                        .directory_ = "ToobAmp.lv2",
                        .patchProperty_ = "http://two-play.com/plugins/toob-record#audioFile",
                    },
                },
                {
                },
                {
                }
            });
        }
    };
} // namespace
#endif
#ifdef DEFINE_LV2_PLUGIN_BASE
#include <lv2_plugin/Lv2Plugin.hpp>
#include <lv2_plugin/Lv2Ports.hpp>
using namespace lv2c::lv2_plugin;

namespace record_plugin{
    class StereoRecordPluginBase: public Lv2PluginWithState {
    public:
        static constexpr const char* URI = "http://two-play.com/plugins/toob-record-stereo";
        StereoRecordPluginBase(double rate,const char*bundlePath,const LV2_Feature *const *features)
        :   Lv2PluginWithState(rate,bundlePath,features)
        {
            audioFile_urid = MapURI("http://two-play.com/plugins/toob-record#audioFile");
            Lv2Plugin::AddPatchProperty(audioFile_urid);
        }
    public:
        LV2_URID audioFile_urid = 0; // urid for patch property http://two-play.com/plugins/toob-record#audioFile

        virtual bool OnPatchPathSet(LV2_URID propertyUrid,const char*value) = 0;
        virtual const char* OnGetPatchPropertyValue(LV2_URID propertyUrid) = 0;

        enum class PortId {
            stop = 0,
            record = 1,
            record_led = 2,
            play = 3,
            play_led = 4,
            record_time = 5,
            fformat = 6,
            level = 7,
            level_vu = 8,
            in = 9,
            out = 10,
            controlIn = 11,
            controlOut = 12,
            inR = 13,
            outR = 14,
        };

    protected:
        TriggerInputPort stop{};
        TriggerInputPort record{};
        RateLimitedOutputPort record_led{0};
        TriggerInputPort play{};
        RateLimitedOutputPort play_led{0};
        RateLimitedOutputPort record_time{0};
        RangedInputPort fformat{0,3};
        RangedDbInputPort level{-60,30};
        VuOutputPort level_vu{-60,20};
        AudioInputPort in{};
        AudioOutputPort out{};
        AtomInputPort controlIn{};
        AtomOutputPort controlOut{};
        AudioInputPort inR{};
        AudioOutputPort outR{};

        virtual void ConnectPort(uint32_t port, void *data) override
        {
            switch ((PortId)port)
            {
            case PortId::stop:
                stop.SetData(data);
                break;
            case PortId::record:
                record.SetData(data);
                break;
            case PortId::record_led:
                record_led.SetData(data);
                break;
            case PortId::play:
                play.SetData(data);
                break;
            case PortId::play_led:
                play_led.SetData(data);
                break;
            case PortId::record_time:
                record_time.SetData(data);
                break;
            case PortId::fformat:
                fformat.SetData(data);
                break;
            case PortId::level:
                level.SetData(data);
                break;
            case PortId::level_vu:
                level_vu.SetData(data);
                break;
            case PortId::in:
                in.SetData(data);
                break;
            case PortId::out:
                out.SetData(data);
                break;
            case PortId::controlIn:
                controlIn.SetData(data);
                break;
            case PortId::controlOut:
                controlOut.SetData(data);
                break;
            case PortId::inR:
                inR.SetData(data);
                break;
            case PortId::outR:
                outR.SetData(data);
                break;
            default:
                LogError("Invalid port id");
                break;
            }
        }
        virtual void Activate() override
        {
            SetAtomPortBuffers((LV2_Atom_Sequence*)(controlIn.Get()), (LV2_Atom_Sequence*)(controlOut.Get()));
            record_led.SetSampleRate((float)getRate());
            play_led.SetSampleRate((float)getRate());
            record_time.SetSampleRate((float)getRate());
            level_vu.SetSampleRate((float)getRate());
        }
    };
} // namespace
#endif
