// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

class ToobTunerInfo: public lv2c::ui::Lv2PluginInfo{
public:
    static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-tuner-ui";
    using super=lv2c::ui::Lv2PluginInfo;
    using ptr=std::shared_ptr<ToobTunerInfo>;
    static ptr Create() { return std::make_shared<ToobTunerInfo>(); }

    ToobTunerInfo() {
        using namespace lv2c::ui;

        uri("http://two-play.com/plugins/toob-tuner");
        name("TooB Tuner");
        brand("");
        label("TooB Tuner");
        plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
        supported_features({"http://lv2plug.in/ns/ext/worker#schedule","http://lv2plug.in/ns/ext/urid#map","http://lv2plug.in/ns/lv2core#hardRTCapable"});
        required_features({"http://lv2plug.in/ns/ext/worker#schedule","http://lv2plug.in/ns/ext/urid#map"});
        optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
        author_name("Robin Davies");
        author_homepage("https://github.com/sponsors/rerdavies");
        comment("TooB Tuner is a chromatic guitar tuner.");
        extensions({"http://lv2plug.in/ns/ext/state#interface","http://lv2plug.in/ns/ext/worker#interface"});
        ports({
            Lv2PortInfo_Init {
                .index_ = 0,
                .symbol_ = "FREQ",
                .name_ = "Freq",
                .min_value_ = -1,
                .max_value_ = 128,
                .default_value_ = -1,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::midiNote,
            },
            Lv2PortInfo_Init {
                .index_ = 1,
                .symbol_ = "MUTE",
                .name_ = "Mute",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .integer_property_ = true,
                .toggled_property_ = true,
                .comment_ = "Mute plugin output",
            },
            Lv2PortInfo_Init {
                .index_ = 2,
                .symbol_ = "REFFREQ",
                .name_ = "Ref Freq",
                .min_value_ = 425,
                .max_value_ = 455,
                .default_value_ = 440,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::hz,
                .comment_ = "The pitch standard frequency of the note A4",
            },
            Lv2PortInfo_Init {
                .index_ = 3,
                .symbol_ = "THRESHOLD",
                .name_ = "Threshold",
                .min_value_ = -60,
                .max_value_ = 0,
                .default_value_ = -37,
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_control_port_ = true,
                .units_ = Lv2Units::db,
                .comment_ = "The minimum volume of the input signal for which pitch values will be displayed.",
            },
            Lv2PortInfo_Init {
                .index_ = 4,
                .symbol_ = "in",
                .name_ = "In",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 5,
                .symbol_ = "out",
                .name_ = "Out",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_audio_port_ = true,
            },
            Lv2PortInfo_Init {
                .index_ = 6,
                .symbol_ = "control",
                .name_ = "Control",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                .is_input_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
            Lv2PortInfo_Init {
                .index_ = 7,
                .symbol_ = "notify",
                .name_ = "Notify",
                .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/ext/atom#AtomPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                .is_output_ = true,
                .is_atom_port_ = true,
                .buffer_type_ = Lv2BufferType::Sequence,
                .designation_ = "http://lv2plug.in/ns/lv2core#control",
                .comment_ = "Plugin to GUI communication",
            },
        });
        port_groups({});
        has_factory_presets(false);
        piPedalUI(PiPedalUI{
            {
            },
            {
            },
            {
            }
        });
    }
};
#endif
