// Autogenerated by generate_lv2c_plugin_info. Do not modify.

#ifndef DEFINE_LV2_PLUGIN_BASE
#include "lv2c_ui/Lv2PluginInfo.hpp"
#include <memory>

namespace volume_plugin{
    class ToobVolumeUiBase: public lv2c::ui::Lv2PluginInfo{
    public:
        static constexpr const char* UI_URI = "http://two-play.com/plugins/toob-volume-ui";
        using super=lv2c::ui::Lv2PluginInfo;
        using ptr=std::shared_ptr<ToobVolumeUiBase>;
        static ptr Create() { return std::make_shared<ToobVolumeUiBase>(); }

        ToobVolumeUiBase() {
            using namespace lv2c::ui;

            uri("http://two-play.com/plugins/toob-volume");
            name("TooB Volume");
            brand("TooB");
            label("TooB Volume");
            plugin_class("http://lv2plug.in/ns/lv2core#Plugin");
            supported_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            required_features({});
            optional_features({"http://lv2plug.in/ns/lv2core#hardRTCapable"});
            author_name("Robin Davies");
            author_homepage("https://github.com/sponsors/rerdavies");
            comment("Volume control.\n\nTooB Volume operates on a monophonic signal. Use the TooB Mix plugin to set volume levels on a \nstereophonic signal.");
            extensions({});
            ports({
                Lv2PortInfo_Init {
                    .index_ = 0,
                    .symbol_ = "vol",
                    .name_ = "Volume",
                    .min_value_ = -60,
                    .max_value_ = 30,
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#ControlPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .scale_points_ = {Lv2ScalePoint{-60,"-INF"}},
                    .is_input_ = true,
                    .is_control_port_ = true,
                    .units_ = Lv2Units::db,
                    .comment_ = "Volume",
                },
                Lv2PortInfo_Init {
                    .index_ = 1,
                    .symbol_ = "in",
                    .name_ = "In",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#InputPort"}},
                    .is_input_ = true,
                    .is_audio_port_ = true,
                },
                Lv2PortInfo_Init {
                    .index_ = 2,
                    .symbol_ = "out",
                    .name_ = "Out",
                    .classes_ = Lv2PluginClasses{{"http://lv2plug.in/ns/lv2core#AudioPort","http://lv2plug.in/ns/lv2core#OutputPort"}},
                    .is_output_ = true,
                    .is_audio_port_ = true,
                },
            });
            port_groups({});
            has_factory_presets(false);
            piPedalUI(PiPedalUI{
                {
                },
                {
                },
                {
                }
            });
        }
    };
} // namespace
#endif
#ifdef DEFINE_LV2_PLUGIN_BASE
#include <lv2_plugin/Lv2Plugin.hpp>
#include <lv2_plugin/Lv2Ports.hpp>
using namespace lv2c::lv2_plugin;

namespace volume_plugin{
    class ToobVolumeBase: public Lv2Plugin {
    public:
        static constexpr const char* URI = "http://two-play.com/plugins/toob-volume";
        ToobVolumeBase(double rate,const char*bundlePath,const LV2_Feature *const *features)
        :   Lv2Plugin(rate,bundlePath,features)
        {
        }
    public:

        enum class PortId {
            vol = 0,
            in = 1,
            out = 2,
        };

    protected:
        RangedDbInputPort vol{-60,30};
        AudioInputPort in{};
        AudioOutputPort out{};

        virtual void ConnectPort(uint32_t port, void *data) override
        {
            switch ((PortId)port)
            {
            case PortId::vol:
                vol.SetData(data);
                break;
            case PortId::in:
                in.SetData(data);
                break;
            case PortId::out:
                out.SetData(data);
                break;
            default:
                LogError("Invalid port id");
                break;
            }
        }
        virtual void Activate() override
        {
            SetAtomPortBuffers((LV2_Atom_Sequence*)(nullptr), (LV2_Atom_Sequence*)(nullptr));
        }
    };
} // namespace
#endif
